/**
 * Este modulo provee de las operaciones necesarias para la simulacion de cookies a traves de la base de datos.
 * Estas cokkies estan representadas en la base de datos, en la tabla "cokkies"
 **/

var Cookie = function(){
}

Cookie.prototype = {
	/**
	 * Crea la cookie en la base de datos.
	 * -Parametros-
	 * name: nombre de la cookie
	 * value: valor
	 **/
	create: function create (name, value){
		var user_screen_name;
		try{
			if(twitbin.cookie.exist(name)){
				//existia la cookie
				this.remove(name);
			}
			user_screen_name = twitbin.getLoggedUserName();

			twitbin.dbtwitbin.query("insert into cookies (twitbin_user_screen_name, name, value) values ('"+user_screen_name+"','"+name+"','"+twitbin.encript.rawEncode(value)+"')");
		}catch(e){
			twitbin.debug.showMessage("No se pudo escribir la cookie en la base de datos en funcion 'cookie.create'.");
		}
	},

	/**
	 * Lee una cookie.
	 * -Parametros-
	 * name: nombre de la cookie que se desea leer
	 * global: este parametro indica si la cookie debe ser leida en un ambito global ( sin un usuario logueado ).
	 * en el caso de que global sea true, entonces se utiliza el usuario generico "anonymous"
	 **/
	read: function read(name,global){
		var res,
		user_screen_name = "anonymous";

		try{
			if(typeof(global)=="undefined"){
				user_screen_name = twitbin.getLoggedUserName();
			}
			res = twitbin.dbtwitbin.query("select value from cookies where (name ='"+name+"' and twitbin_user_screen_name = '"+user_screen_name+"')");
			if(typeof(res[0])!="undefined"){
				return twitbin.encript.rawDecode(res[0].value);
			}
			return null;
		}catch(e){
			//twitbin.debug.showMessage("No se pudo leer la cookie de la base de datos en funcion 'cookie.read'.");
		}
	},

	/**
	 * Elimina una cookie.
	 * -Parametros-
	 * name: nombre de la cookie que se desea eliminar
	 * global: este parametro indica si la cookie debe ser eliminada en un ambito global ( sin un usuario logueado ).
	 * en el caso de que global sea true, entonces se utiliza el usuario generico "anonymous"
	 **/
	remove: function remove(name,global){
		var user_screen_name = "anonymous";

		try{
			if(typeof(global)=="undefined"){
				user_screen_name = twitbin.getLoggedUserName();
			}
			twitbin.dbtwitbin.query("delete from cookies where (name ='"+name+"' and twitbin_user_screen_name = '"+user_screen_name+"')");
		}catch(e){
			twitbin.debug.showMessage("No se pudo borrar la cookie en la base de datos en funcion 'cookie.remove'.");
		}
	},

	/**
	 * Chequea la existencia de una cookie
	 * -Parametros-
	 * name: nombre de la cookie que se desea buscar
	 * global: este parametro indica si la cookie debe ser chequeada en un ambito global ( sin un usuario logueado ).
	 * en el caso de que global sea true, entonces se utiliza el usuario generico "anonymous"
	 **/
	exist: function exist(name,global){
		var res;

		try{
			if(typeof(global)!="undefined"){
				res = twitbin.cookie.read(name,global);
			}else{
				res = twitbin.cookie.read(name);
			}
			if(res[0] != null){
				return true;
			}
			return false; 
		}catch(e){
			twitbin.debug.showMessage("No se pudo determinar si existe la cookie '"+name+"' en la base de datos en funcion 'cookie.exist'.");
		}
	},


	/**
	 * Trunca la tabla cookies.
	 **/
	clear: function clear(){
		twitbin.dbtwitbin.truncateTable_cookies();
	},
}
