/**
 * Este modulo mantiene las operaciones necesarias para el manejo de la base de datos.
 **/
var DBHandler = function(){
	this.twitDB = new dbSQLite("twitbinDB.sqlite",{location:'ProfD'});
	this.twitDB.execute('PRAGMA synchronous=OFF');
	this.twitDB.execute("PRAGMA default_cache_size ='10000'");
	this.updateInfo = {
		"minVersion":"3.0",
		"availables":["3.0","3.0.1","3.0.2","3.0.3"],
		"from":{
			"3.0":{
				"to":"3.0.1",
				"to_do":[ 
					{"f1":"twitbin.dbtwitbin.truncateTable_temp_tweets","p1":null}
				]
			},
			"3.0.1":{
				"to":"3.0.2",
				"to_do":[
					{"f1":"twitbin.dbtwitbin.updateTable_preferences","p1":null}
				]
			}/*,
			"3.0.2":{
				"to":"3.0.3",
				"to_do":[
					{"f1":"twitbin.dbtwitbin.truncateTable_temp_tweets","p1":null}
				]
			}*/
		}
	};
}

DBHandler.prototype = {
	/**
	 * Realiza una consulta a la base de datos 
	 **/
	query: function query(query){
		return this.twitDB.execute(query);
	},

	/**
	 * Crea la base de datos de twitbin
	 **/
	create_database: function create_database(){
		this.twitDB.createDB();
	},

	/**
	 * trunca la tabla users
	 **/
	truncateTable_users: function truncateTable_users(){
		this.twitDB.twitDBcreateTableUsers();
	},

	/**
	 * trunca la tabla preferences
	 **/
	truncateTable_preferences: function truncateTable_preferences(){
		this.twitDB.createTablePreferences();
	},


	updateTable_preferences: function updateTable_preferences(){
		var i,
		res = twitbin.dbtwitbin.query("SELECT *  FROM preferences WHERE 1");

		if(typeof(res[0])=="undefined"){ return false; }

		this.truncateTable_preferences();
		for(i=0; i < res.length; i++){
			twitbin.dbtwitbin.query("insert into preferences (keep_session, tab, reload_rate, refreshOneByOne, sidebar_position, image_uploader) values ('"+res[i].keep_session+"','"+res[i].tab+"','"+res[i].reload_rate+"','"+res[i].refreshOneByOne+"','"+res[i].sidebar_position+"','pikchur')");
		}
	},

	/**
	 * trunca la tabla temp_tweets
	 **/
	truncateTable_temp_tweets: function truncateTable_temp_tweets(){
		this.twitDB.createTableTemp_tweets();
	},

	
	/**
	 * trunca la tabla lists
	 **/
	truncateTable_lists: function truncateTable_lists(){
		this.twitDB.createTableLists();
	},

	/**
	 * trunca la tabla tweet_lists
	 **/
	truncateTable_tweet_Lists: function truncateTable_tweet_Lists(){
		this.twitDB.createTableTweet_Lists();
	},

	/**
	 * trunca la tabla searches
	 **/
	truncateTable_searches: function truncateTable_searches(){
		this.twitDB.createTableSearches();
	},

	/**
	 * trunca la tabla tweets_search
	 **/
	truncateTable_tweets_search: function truncateTable_tweets_search(){
		this.twitDB.createTableTweets_search();
	},

	/**
	 * trunca la tabla direct_messages
	 **/
	truncateTable_direct_messages: function truncateTable_direct_messages(){
		this.twitDB.createTableDirect_messages();
	},

	/**
	 * trunca la tabla tweets
	 **/
	truncateTable_tweets: function truncateTable_tweets(){
		this.twitDB.createTableTweets();
	},

	/**
	 * trunca la tabla cookies
	 **/
	truncateTable_cookies: function truncateTable_cookies(){
		this.twitDB.createTableCookies();
	},

	/**
	 * trunca la tabla error_log
	 **/
	truncateTable_error_log: function truncateTable_error_log(){
		this.twitDB.createTableErrorlog();
	},

	/**
	 * trunca la tabla twitbin
	 **/
	truncateTable_twitbin: function truncateTable_twitbin(){
		this.twitDB.createTableTwitbin();
	},

	/**
	 * Actualiza la base de datos, segun las indicaciones de this.updateInfo. 
	 **/
	updateDatabase: function (currentVersion,newVersion){
		var aux_currentVersion,functionsToDo,
		num_currentVersion = parseFloat(currentVersion),
		num_newVersion = parseFloat(newVersion);

		twitbin.dbtwitbin.query("UPDATE twitbin SET version ='"+newVersion+"'");

		//El usuario vuelve a una version anterior.
		if(num_currentVersion > num_newVersion){twitbin.create_database(newVersion);  return true; }

		//El usuario tiene una version anterior a la minima version disponible
		if(num_currentVersion < parseFloat(this.updateInfo.minVersion)){twitbin.create_database(newVersion);  return true; }

		aux_currentVersion = currentVersion;

		while(aux_currentVersion < newVersion){
			//intenta obtener informacion que indique como actuar para actualizar a la nueva version.
			try{
				functionsToDo = this.updateInfo.from[aux_currentVersion].to_do;
			}catch(e){
				return false;
			}

			for(var i=0;i<functionsToDo.length;i++){
				twitbin.callback.execute(functionsToDo[i]);
			}
			aux_currentVersion = this.updateInfo.from[aux_currentVersion].to;//asigno la nueva version actual.
 		}
	},
}
