var Twitbin= function(){
	this.dbtwitbin = new DBHandler();
	this.xhr = new Communication();
	this.twitter = new Twitter();
	this.callback = new CallBack();
	this.encript = new Encript();
	this.errorLog = new ErrorLog();
	this.taskScheduler = new TaskScheduler();
	this.shortenUrl = new ShortenUrl();
	this.cookie = new Cookie();
	this.debug = new Debug();
	this.utils = new Util();
	//this.debug.activate();
	this.mediaUploader = new MediaUpload(document.getElementById('form'));
	this.viewController = new ViewController();
	this.reports = new Reports();
	this.message = new Message();
	//this.bitly = new BitLy();
	//this.bitly.init();
	this.logedUser = null;
	this.http_short_url_length = 25;
	this.maxTweetOfSearches = 100;
	this.maxTweetOfLists = 100;
	this.mainWindow= Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator).getMostRecentWindow("navigator:browser");
	this.gClipboardHelper = Components.classes["@mozilla.org/widget/clipboardhelper;1"].getService(Components.interfaces.nsIClipboardHelper);
	this.onStart = true;
	this.onInitSession = true;
	this.correctLogin = false;
}

Twitbin.prototype = {


//--------------------------------------------
//	 INIT: admintrative functions
//--------------------------------------------

	init: function init (){
		//obtain the current version of twitbin
		Components.utils.import("resource://gre/modules/AddonManager.jsm");
		AddonManager.getAddonByID("ntortarolo@hotmail.com", function(addon) {
			var version = addon.version+'';
			twitbin.check_database(version);
			twitbin.start();
		});
	},

	check_database: function check_database(version){
		try{
			var mainWindow, res = twitbin.dbtwitbin.query("SELECT version FROM twitbin");
			// no tenia ese campo
			if(typeof(res[0]) =="undefined"){twitbin.create_database(version);  return true; }

			//Existe la base de datos
			if(res[0].version != version){
 				twitbin.openUrl('http://twitbin.com/welcome');
 				twitbin.dbtwitbin.updateDatabase(res[0].version,version);

				//agrego el icono en el top nav
				mainWindow = window.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
				.getInterface(Components.interfaces.nsIWebNavigation)
				.QueryInterface(Components.interfaces.nsIDocShellTreeItem)
				.rootTreeItem
				.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
				.getInterface(Components.interfaces.nsIDOMWindow);

				mainWindow.twitbinOver.addIconToNavBar();
			}
		}catch(e){
			//la crea de nuevo porque la tabla no existe
 			twitbin.create_database(version);
			twitbin.openUrl('http://twitbin.com/welcome');
		}
	},

	create_database: function (version){
		twitbin.dbtwitbin.create_database();
		twitbin.dbtwitbin.query("insert into twitbin (version,last_sidebar_position) values ('"+version+"','left')");
	},

//--------------------------------------------
//	 INIT: Starting ...
//--------------------------------------------

	start: function start (){

		twitbin.startBarPosition();

		//Comienza la ejecucion del task scheduler.
		twitbin.taskScheduler.init();

		//mostra pantalla de login
		twitbin.viewController.viewInterface.init();

		//obtener tweets publicos
		twitbin.dbtwitbin.truncateTable_temp_tweets();

		twitbin.loadPublicTweets();
		
		//obtener longitud reservada para las urls acortadas
		twitbin.getConfiguration();
	},

	startBarPosition: function startBarPosition(position) {

		var position, 
		res = twitbin.dbtwitbin.query("SELECT last_sidebar_position FROM twitbin");
		position = res[0].last_sidebar_position;

		if (position == "right") {
			top.document.getElementById("browser").style.MozBoxDirection ="reverse";
			return true;
		}

		top.document.getElementById("browser").style.MozBoxDirection ="normal";
		return true;
	},

//--------------------------------------------
//	 DELETE USER
//--------------------------------------------

	deleteUserIfExist: function deleteUserIfExist(username){
		var res1,
		res = twitbin.dbtwitbin.query("SELECT user_preferences FROM users WHERE name = '"+username+"'");
		if(typeof(res[0])!="undefined"){
			res1 = twitbin.dbtwitbin.query("DELETE FROM users WHERE ( name = '"+username+"')");
			res1 = twitbin.dbtwitbin.query("DELETE FROM preferences WHERE ( id = '"+res[0].user_preferences+"')");
			res1 = twitbin.dbtwitbin.query("DELETE FROM cookies WHERE (  twitbin_user_screen_name = '"+username+"')");
			res1 = twitbin.dbtwitbin.query("DELETE FROM direct_messages WHERE (  twitbin_user_screen_name = '"+username+"')");
			res1 = twitbin.dbtwitbin.query("DELETE FROM lists WHERE (  twitbin_user_screen_name = '"+username+"')");
			res1 = twitbin.dbtwitbin.query("DELETE FROM searches WHERE (  twitbin_user_screen_name = '"+username+"')");
			res1 = twitbin.dbtwitbin.query("DELETE FROM temp_tweets WHERE (  twitbin_user_screen_name = '"+username+"')");
			res1 = twitbin.dbtwitbin.query("DELETE FROM tweets WHERE (  twitbin_user_screen_name = '"+username+"')");
			res1 = twitbin.dbtwitbin.query("DELETE FROM tweets_search WHERE (  twitbin_user_screen_name = '"+username+"')");
		}
	},

//--------------------------------------------
//	 REGISTER USER && AND LOGIN HIM
//--------------------------------------------

	//called from add New account click event
	requestPin: function  (){
		twitbin.utils.callHandler({"f1":"requestToken","p1":null,"f2":"twitbin.afterRequestPin","p2":null},'twitter');
	},

	afterRequestPin: function (response) {
		if(typeof(response.oauth_token) == "undefined"){
			//TODO: volver a mostrar pantalla de add user/login
		 }
		this.cookie.create("pin_auth_token",response.oauth_token);
		this.cookie.create("pin_auth_token_secret",response.oauth_token_secret);
		this.openAuthorizeUrl('https://api.twitter.com/oauth/authorize?force_login=true&oauth_token=' + response.oauth_token);
		twitbin.viewController.viewInterface.AddUserForm('show');
	},

	//called from create account click event
	authorize: function (action,userPass, pin){

		var auth_token = this.cookie.read("pin_auth_token"),
		auth_token_secret = this.cookie.read("pin_auth_token_secret"),
		userPassword = null;

		this.cookie.remove("pin_auth_token");
		this.cookie.remove("pin_auth_token_secret");
		if(userPass != ""){ userPassword = userPass; }

		twitbin.utils.callHandler({"f1":"Auth","p1":[pin,auth_token, auth_token_secret],"f2":"twitbin.afterAuthorize","p2":[action,userPassword]},'twitter');
	},

	afterAuthorize: function (action,userPass,response){

		if(typeof(response.error)!="undefined"){
			twitbin.closeTwitterPinPage();//cierro la pagina de twitter
			twitbin.viewController.viewInterface.resetAddNewAccountFields();//reseteo los campos del pin
			twitbin.twitter.oauth.tokens = null;//seteo a null los tokens de OAuth
			twitbin.requestPin();//vuevo a pedir el pin
			$("#addNewUserWhait").fadeIn();
			$("#addNewUser p.pin_error_novalid").show('fast');//aviso que el pin ingresado es invalido
			return false;
		}

		twitbin.viewController.viewInterface.HideUserForm();
		twitbin.closeTwitterPinPage();

		twitbin.twitter.tokenAuth = response; //guardo el token para guardar el logueo.
		twitbin.twitter.oauth.setTokens(response.oauth_token,response.oauth_token_secret);
		twitbin.logedUser = {"twitter_id":response.user_id, "screen_name":response.screen_name, "profile_image":null};
		twitbin.twitter.setLoggedUser(response);

		if(action == 'remember'){
			//obtiene los datos del usuario (imagen), guarda el usuario y luego lo loguea.
			twitbin.utils.callHandler({"f1":"getUserInformation","p1":[response.screen_name],"f2":"twitbin.saveUserAndInitSession","p2":[userPass]},'twitter');
		}else if(action == 'Notremember'){
			twitbin.logTempUser(response);
		}
	},

	saveUserAndInitSession: function saveUserAndInitSession(userPass,user_info){
		
		if(typeof(user_info.error)!="undefined") { 
			twitbin.viewController.viewInterface.waitPage("hide");
			twitbin.viewController.viewInterface.messageForLogin('show');
			twitbin.logOut();
			return false;
		}

		var res,id_preferences,
		user = {"screen_name":twitbin.logedUser.screen_name, "profile_image":user_info.profile_image_url ,"user_id":twitbin.logedUser.twitter_id ,"oauth_token":twitbin.twitter.oauth.tokens.oauth_token ,"oauth_token_secret":twitbin.twitter.oauth.tokens.oauth_token_secret};

		if(userPass == null){ userPass = '';}

		//actualizo el usuario logueado en twitbin con la imagen
		twitbin.logedUser = {"twitter_id":user.user_id, "screen_name":user.screen_name, "profile_image":user.profile_image,"time_zone":user_info.time_zone};

		//Si el usuario existe lo elimino junto con sus preferencias
		twitbin.deleteUserIfExist(user.screen_name);
		//guardo las preferencias por defecto y el usuario en la DB.
		this.dbtwitbin.query("insert into preferences (keep_session, tab, reload_rate, refreshOneByOne, sidebar_position, image_uploader) values (0,'friends',1,1,'left','pikchur')");
		res = this.dbtwitbin.query("Select last_insert_rowid() as id");
		id_preferences = res[0].id;
		//guardo el usuario
		this.dbtwitbin.query("insert into users (name, profile_image, twitter_id, access_token, secret_token, user_preferences, password)values ('"+user.screen_name+"', '"+user.profile_image+"', '"+user.user_id+"', '"+user.oauth_token+"', '"+user.oauth_token_secret+"','"+id_preferences+"','"+userPass+"')");

		//inicio la sesion
		twitbin.pre_init_session(user.screen_name);
	},

	logTempUser: function logTempUser(user_info){
		var user = {"screen_name":twitbin.logedUser.screen_name, "profile_image":user_info.profile_image_url ,"user_id":twitbin.logedUser.twitter_id ,"oauth_token":twitbin.twitter.oauth.tokens.oauth_token ,"oauth_token_secret":twitbin.twitter.oauth.tokens.oauth_token_secret};

		//actualizo el usuario logueado en twitbin con la imagen
		twitbin.logedUser = {"twitter_id":user.user_id, "screen_name":user.screen_name, "profile_image":user.profile_image,"time_zone":user_info.time_zone};

		//inicio la sesion
		twitbin.pre_init_session(user.screen_name);
	},

//--------------------------------------------
//	 LOGIN USER
//--------------------------------------------

	//called from click on a user event
	LogUser: function LogUser(id){
		var user = this.getUser(id);

		if(user){
			twitbin.twitter.oauth.setTokens(user[0].access_token,user[0].secret_token);
			twitbin.logedUser = {"twitter_id":user[0].twitter_id, "screen_name":user[0].name};
			twitbin.twitter.LoggedUser = {'user_id':user[0].twitter_id, 'screen_name':user[0].name};

			//actualiza los datos del usuario (imagen) antes de loguear
			twitbin.utils.callHandler({"f1":"getUserInformation","p1":[user[0].name],"f2":"twitbin.afterLogUser","p2":null},'twitter');
		}
	},

	afterLogUser: function (user_info){

		if(typeof(user_info.error)!="undefined"){
			twitbin.viewController.viewInterface.waitPage("hide");
			twitbin.viewController.viewInterface.messageForLogin('show');
			twitbin.logOut();
			return false;
		}

		//actualizo el usuario logueado en twitbin con la imagen
		var res,
		user = {"screen_name":twitbin.logedUser.screen_name, "profile_image":user_info.profile_image_url ,"user_id":twitbin.logedUser.twitter_id ,"oauth_token":twitbin.twitter.oauth.tokens.oauth_token ,"oauth_token_secret":twitbin.twitter.oauth.tokens.oauth_token_secret};

		twitbin.logedUser = {"twitter_id":user.user_id, "screen_name":user.screen_name, "profile_image":user.profile_image,"time_zone":user_info.time_zone};
		res = twitbin.dbtwitbin.query("UPDATE users SET profile_image='"+user_info.profile_image_url+"' WHERE (name='"+user.screen_name+"')");

		//inicio la sesion
		twitbin.pre_init_session(user.screen_name);
	},

	logOut: function logOut(){
		twitbin.viewController.viewInterface.cancelTweet();
		twitbin.taskScheduler.finish();
		twitbin.reports.send();
		twitbin.twitter.oauth.tokens = null;
		twitbin.logedUser = null;
		twitbin.twitter.LoggedUser = null;
		twitbin.onInitSession = true;
		this.onStart = true;
		twitbin.cookie.clear();
		twitbin.start();
		twitbin.correctLogin = false;
	},

//--------------------------------------------
//	 INIT SESSION
//--------------------------------------------

	pre_init_session: function (user_screen_name) {
		//show whait page
		twitbin.viewController.viewInterface.waitPage('show');

		//cargo las preferencias del usuario
		twitbin.loadPreferences(user_screen_name);

		//inicio la sesion
		twitbin.init_session();
	},

	loadPreferences: function loadPreferences(user_screen_name){

		if(!twitbin.userLogged()){ return false; }

		var res,
		q = "SELECT P.reload_rate reload_rate, P.sidebar_position sidebar_position, P.image_uploader image_uploader, P.tab tab FROM (SELECT user_preferences FROM users WHERE (name = '"+user_screen_name+"')) U , (SELECT * FROM preferences WHERE 1) P WHERE P.id = U.user_preferences";
		res = twitbin.dbtwitbin.query(q);

		if(typeof(res[0])=="undefined"){ return false; }

		twitbin.setImageUploader(res[0].image_uploader);
		twitbin.taskScheduler.defaultTime = parseInt(res[0].reload_rate);

		if(res[0].sidebar_position == 'right'){
			twitbin.updateBarPosition('right');
			res = twitbin.dbtwitbin.query("UPDATE twitbin SET last_sidebar_position='right'");
		}else{
			twitbin.updateBarPosition('left');
			res = twitbin.dbtwitbin.query("UPDATE twitbin SET last_sidebar_position='left'");
		}
	},

	setImageUploader: function setImageUploader(uploader){
		twitbin.mediaUploader.setMediaUploader(uploader);
		twitbin.viewController.viewInterface.setImageUploader(uploader);
	},

	updateBarPosition: function updateBarPosition(position) {

		if (position == "right") {
			top.document.getElementById("browser").style.MozBoxDirection ="reverse";
			return true;
		}

		top.document.getElementById("browser").style.MozBoxDirection ="normal";
		return true;
	},

	init_session: function init_session(){

		twitbin.reports.init();

		//obtengo todos los tweets favoritos y retwweted desde twitter para lograr consistencia.
		twitbin.synchronizeFavorites();
		twitbin.synchronizeRetweetedByMe();

		//inicio los task scheluders que va a darme los nuevos twitws
		twitbin.taskScheduler.add({"f1":"twitbin.loadAllList","p1":null},'15',true);//obtener todas las listas del usuario
		twitbin.taskScheduler.add({"f1":"twitbin.loadAllSearches","p1":null},twitbin.taskScheduler.defaultTime);//obtener todas las busquedas

		twitbin.taskScheduler.add({"f1":"twitbin.LoadDirectMessages","p1":null},twitbin.taskScheduler.defaultTime);//obtener nuevos mensajes directos recibidos
		twitbin.taskScheduler.add({"f1":"twitbin.LoadDirectMessagesSent","p1":null},twitbin.taskScheduler.defaultTime);//obtener nuevos mensajes directos enviados

		twitbin.correctLogin = false;
		//este es el que va a mostrar el timeline al iniciar session
		twitbin.taskScheduler.add({"f1":"twitbin.loadTimeLineTweets","p1":null},twitbin.taskScheduler.defaultTime);//obtener nuevos tweets de home timeline
		twitbin.taskScheduler.setUniqueExecutionFunction({"f1":"twitbin.checkLogin","p1":null},15000);//checkea que el login del usuario se haya hecho correctamente.

		twitbin.taskScheduler.add({"f1":"twitbin.loadMentionsTweets","p1":null},twitbin.taskScheduler.defaultTime);//obtener nuevas mensiones sobre el usuario

		//seteo el nombre del usuario en los lugares corerspondientes de la vista

		if(!twitbin.cookie.exist('Setedurl', true)){
			$("#searchbox textarea").val('Share something, '+ twitbin.getLoggedUserName());
		}else{
			twitbin.cookie.remove('Setedurl', true);
		}
		$("#signOutTwitbin a").html('Sign out '+ twitbin.utils.escapeHTML(twitbin.getLoggedUserName()));

		//ejecuta todas las funciones previamente cargadas
		twitbin.functionsToExecuteOnInit();
	},

	checkLogin: function checkLogin(){
		if(!twitbin.correctLogin){
			twitbin.viewController.viewInterface.waitPage("hide");
			twitbin.viewController.viewInterface.messageForLogin('show');
			twitbin.logOut();
			return false;
		}
		return true;
	},
//--------------------------------------------
//	 RATE LIMIT ACTIONS
//--------------------------------------------

	getRateLimitStatus: function getRateLimitStatus(){
		if(!twitbin.userLogged()){ return false; }

		twitbin.utils.callHandler({"f1":"getRateLimitStatus","p1":null,"f2":"twitbin.afterGetRateLimitStatus","p2":null},'twitter');
	},

	afterGetRateLimitStatus: function afterGetRateLimitStatus(ratelimit){
		if(!twitbin.userLogged()){ return false; }

		//TODO: agregar acciones a realizar --????--
	},

//--------------------------------------------
//	 TWITTER USER ACTIONS
//--------------------------------------------

	//------------

	follow_unfollow: function follow_unfollow(screen_name_b,user_id){
		if(!twitbin.userLogged()){ return false; }

		var screen_name_a = this.getLoggedUserName();
		twitbin.utils.callHandler({"f1":"hasFriendship","p1":[screen_name_a,screen_name_b],"f2":"twitbin.afterFollow_unfollow","p2":[screen_name_b,user_id]},'twitter');
	},

	afterFollow_unfollow: function afterFollow_unfollow(screen_name,user_id,response){
		if(!twitbin.userLogged()){ return false; }

		if(typeof(response.error)!="undefined"){

			if( response.error.match(/permission/) ){
				twitbin.sendFollowRequestUser(screen_name,user_id);
				return true;
			}

			this.showErrorMessage(response.error);
			return false;
		}

		if(response){
			twitbin.unfollowUser(screen_name,user_id);
			return true;
		}

		twitbin.followUser(screen_name,user_id);
		return true;
	},

	//------------

	unfollowUser: function unfollowUser(user_screen_name,user_id){
		if(!twitbin.userLogged()){ return false; }

		//report
		twitbin.reports.add('Session.users_follow_unfollow');

		twitbin.utils.callHandler({"f1":"unfollowUser","p1":[user_id,user_screen_name],"f2":"twitbin.afterUnfollowUser","p2":[user_screen_name]},'twitter');
	},

	afterUnfollowUser: function afterUnfollowUser(user_screen_name,response){
		//--????-- para que se pasa user_screen_name

		if(!twitbin.userLogged()){ return false; }

		if(typeof(response.error)!="undefined"){
			//Esta es una opcion para el mensaje de error.
			//this.showErrorMessage("could not unfollow the user, try again");

			this.showErrorMessage(response.error);
			return false;
		}

		//muestro el mensaje que indica que se ha dejado de seguir al usuario.
		this.showErrorMessage("you stop follow the user "+response.screen_name);
	},

	//------------

	followUser: function followUser(user_screen_name,user_id){
		if(!twitbin.userLogged()){ return false; }

		//report
		twitbin.reports.add('Session.users_follow_unfollow');

		twitbin.utils.callHandler({"f1":"followUser","p1":[user_id,user_screen_name],"f2":"twitbin.afterFollowUser","p2":[user_screen_name]},'twitter');
	},

	afterFollowUser: function afterFollowUser(user_screen_name,response){
		if(!twitbin.userLogged()){ return false; }

		if(typeof(response.error)!="undefined"){
			//Esta es una opcion para el mensaje de error.
			//this.showErrorMessage("could not begin to follow the user, try again");
			this.showErrorMessage(response.error);
			return false;
		}

		this.showErrorMessage("started to follow the user "+user_screen_name);
	},

	//------------

	sendFollowRequestUser: function sendFollowRequestUser(user_screen_name,user_id){
		if(!twitbin.userLogged()){ return false; }

		twitbin.utils.callHandler({"f1":"followUser","p1":[user_id,user_screen_name],"f2":"twitbin.afterSendFollowRequestUser","p2":[user_screen_name]},'twitter');
	},

	afterSendFollowRequestUser: function afterSendFollowRequestUser(user_screen_name,response){
		if(!twitbin.userLogged()){ return false; }

		var amatch;

		if(typeof(response.error) != "undefined"){ 
			/*
			controlo, si el mensaje comienza con Could not follow user. En el caso de que sea asi
			entonces el mensaje es demaciado largo para mostrarlo, asi que solo muestro la segunda parte
			*/
			amatch = response.error.match(/Could not follow user: /);
			if(amatch){
				this.showErrorMessage( response.error.replace(amatch,'') );
				return false;
			}

			this.showErrorMessage(response.error);
			return false;
		}

		this.showErrorMessage("Your follow request has been sent to "+user_screen_name);
	},

	//------------

	blockUser: function blockUser(user_screen_name,user_id){
		if(!twitbin.userLogged()){ return false; }

		//report
		twitbin.reports.add('Session.users_blocked');

		twitbin.utils.callHandler({"f1":"blockUser","p1":[user_id,user_screen_name],"f2":"twitbin.afterBlockUser","p2":null},'twitter');
	},

	afterBlockUser: function afterBlockUser(response){
		if(!twitbin.userLogged()){ return false; }

		var user_screen_name;

		if(typeof(response.error)!="undefined"){
			this.showErrorMessage(response.error);
			return false;
		}
		user_screen_name = this.getLoggedUserName();
		twitbin.dbtwitbin.query("DELETE FROM tweets WHERE ( twitbin_user_screen_name = '"+user_screen_name+"' AND  owner_screen_name ='"+response.screen_name+"')");
		this.showErrorMessage("the user "+response.screen_name+" has been blocked ");
	},

	//------------

	reportUserAsSpamer: function reportUserAsSpamer(user_screen_name,user_id){
		if(!twitbin.userLogged()){ return false; }

		//report
		twitbin.reports.add('Session.users_reported_as_spamer');

		twitbin.utils.callHandler({"f1":"reportSpam","p1":[user_id,user_screen_name],"f2":"twitbin.afterReportUserAsSpamer","p2":null},'twitter');
	},

	afterReportUserAsSpamer: function afterReportUserAsSpamer(response){
		if(!twitbin.userLogged()){ return false; }

		if(typeof(response.error)!="undefined"){
			this.showErrorMessage(response.error);
			return false;
		}
		this.showErrorMessage("has set the user "+response.screen_name+" as a spammer");
	},

//--------------------------------------------
//	 TWEETS ACTIONS
//--------------------------------------------

	//------------

	updateStatus: function updateStatus(tweet){
		if(!twitbin.userLogged()){ return false; }

		var in_reply_to_status_id = '';

		if(twitbin.cookie.exist('in_reply_to_status_id')){
			in_reply_to_status_id = twitbin.cookie.read('in_reply_to_status_id');
			twitbin.reports.add('Session.replies');
			twitbin.cookie.remove('in_reply_to_status_id');
		}else{
			//report
			twitbin.reports.add('Session.posts');
		}

		twitbin.utils.callHandler({"f1":"newPost","p1":[tweet,in_reply_to_status_id],"f2":"twitbin.afterUpdateStatus","p2":null},'twitter');
	},

	afterUpdateStatus: function afterUpdateStatus(response){
		if(!twitbin.userLogged()){ return false; }

		if(typeof(response.error)!="undefined"){
			twitbin.showErrorMessage(response.error);
			return false;
		}

		twitbin.loadTimeLineTweets();
	},

	//------------

	deleteStatus: function deleteStatus(tweet_id){
		if(!twitbin.userLogged()){ return false; }

		//report
		twitbin.reports.add('Session.deleted_tweets');

		twitbin.viewController.viewInterface.deleteBoxTweet(tweet_id);
		twitbin.utils.callHandler({"f1":"deleteTweet","p1":[tweet_id],"f2":"twitbin.afterDeleteStatus","p2":[tweet_id]},'twitter');
	},

	afterDeleteStatus: function afterDeleteStatus(tweet_id,response){
		if(!twitbin.userLogged()){ return false; }

		if(typeof(response.error)!="undefined"){
			this.showErrorMessage(response.error);
		}

		var user_screen_name = twitbin.getLoggedUserName();
		twitbin.dbtwitbin.query("DELETE FROM tweets WHERE ( twitbin_user_screen_name = '"+user_screen_name+"' AND tweet_id ='"+tweet_id+"')");
		return true;
	},

	//------------

	retweetStatus: function retweetStatus(tweet_id){
		if(!twitbin.userLogged()){ return false; }

		//report
		twitbin.reports.add('Session.retweets');

		//TODO: Esto debe ir en una funcion en viewInterface. JUSTO debajo de la funcion que oculta el box
		$("#"+tweet_id).find(".actions .default .relativeMe a.retweet").addClass("retweeted");
		$("#"+tweet_id).find(".actions .default .relativeMe a.retweet").appendTo($("#"+tweet_id).find(".selected .relativeMe"));

		twitbin.utils.callHandler({"f1":"retweet","p1":[tweet_id],"f2":"twitbin.afterRetweetStatus","p2":[tweet_id]},'twitter');
	},

	afterRetweetStatus: function afterRetweetStatus(tweet_id,response){
		if(!twitbin.userLogged()){ return false; }

		if(typeof(response.error)!="undefined"){
			this.showErrorMessage(response.error);
			return false;
		}

		var retweet_id = response.id_str;
		twitbin.updateTweetAsRetweetedByMe(tweet_id,retweet_id);
	},

	updateTweetAsRetweetedByMe: function updateTweetAsRetweetedByMe(tweet_id,retweet_id){
		if(!twitbin.userLogged()){ return false; }

		var res,
		user_screen_name = this.getLoggedUserName();

		res = twitbin.dbtwitbin.query("UPDATE tweets SET retweeted_by='"+user_screen_name+"' WHERE (tweet_id='"+tweet_id+"' and twitbin_user_screen_name='"+user_screen_name+"')");
		res = twitbin.dbtwitbin.query("UPDATE tweets SET retweet_id ='"+retweet_id+"' WHERE (tweet_id='"+tweet_id+"' and twitbin_user_screen_name='"+user_screen_name+"')");
	},

	retweetWithComments: function retweetWithComments(tweet_id){
		var tweet = twitbin.getTweet(tweet_id);
		twitbin.viewController.viewInterface.openTweetTextarea();
		twitbin.viewController.viewInterface.setTweetTextarea("RT @"+tweet.owner_screen_name+" "+twitbin.encript.rawDecode(tweet.text));
		twitbin.viewController.viewInterface.calculateCharacters();
	},
	
	replyToAll: function replyToAll(tweet_id){
		var tweet,mentions;
		tweet = twitbin.getTweet(tweet_id);
		mentions = this.obtainAllMentions(twitbin.encript.rawDecode(tweet.text));
		twitbin.viewController.viewInterface.openTweetTextarea();

		twitbin.viewController.viewInterface.setTweetTextarea("@"+tweet.owner_screen_name+" "+mentions);
		twitbin.cookie.create('in_reply_to_status_id',tweet_id);
		twitbin.viewController.viewInterface.calculateCharacters();
	},
	
	obtainAllMentions: function obtainAllMentions(tweet_text){
		var mention,mentions,tweet;

		tweet = tweet_text;
		mentions = '';
		//obtengo y reemplazo todas las mensiones
		mention = twitbin.viewController.viewInterface.haveMention(tweet);
		while(typeof(mention) != "boolean"){

				tweet = tweet.replace(mention,'');

				if (mentions == ''){
					mentions += mention;
				}else{
					mentions += ' '+mention;
				}

				mention = twitbin.viewController.viewInterface.haveMention(tweet);
		}
		return mentions;
	},
	//------------

	removeRetweet: function removeRetweet(tweetId){
		if(!twitbin.userLogged()){ return false; }

		var res,
		user_screen_name = this.getLoggedUserName();

		res = twitbin.dbtwitbin.query("SELECT retweet_id FROM tweets WHERE (twitbin_user_screen_name='"+user_screen_name+"' and retweeted_by='"+user_screen_name+"' and tweet_id= '"+tweetId+"')");
		if(typeof(res[0])=="undefined"){// si es indefinido, entonces el tweet no existe, por lo tanto se muestra el mensaje
			this.showErrorMessage("could not remove the retweet");
			return false;
		}
		twitbin.deleteStatus(res[0].retweet_id);//elimino el retweet
		twitbin.updateTweetAsNotRetweeted(tweetId);
	},

	updateTweetAsNotRetweeted: function updateTweetAsNotRetweeted(tweet_id){
		if(!twitbin.userLogged()){ return false; }

		var res,
		user_screen_name = this.getLoggedUserName();

		res = twitbin.dbtwitbin.query("UPDATE tweets SET retweeted_by='null' WHERE (tweet_id='"+tweet_id+"' and twitbin_user_screen_name='"+user_screen_name+"')");
		res = twitbin.dbtwitbin.query("UPDATE tweets SET retweet_id='null' WHERE (tweet_id='"+tweet_id+"' and twitbin_user_screen_name='"+user_screen_name+"')");
	},

	//-----------

	addTweetToFavorites: function addTweetToFavorites(tweet_id){
		if(!twitbin.userLogged()){ return false; }

		//report
		twitbin.reports.add('Session.tweets_added_to_favorites');

		twitbin.utils.callHandler({"f1":"addToFavorites","p1":[tweet_id],"f2":"twitbin.updateTweetAsFavorite","p2":[tweet_id]},'twitter');
	},

	updateTweetAsFavorite: function updateTweetAsFavorite(tweet_id){
		if(!twitbin.userLogged()){ return false; }

		var res,
		user_screen_name = this.getLoggedUserName();

		res = twitbin.dbtwitbin.query("UPDATE tweets SET favorited=1 WHERE (tweet_id='"+tweet_id+"' and twitbin_user_screen_name='"+user_screen_name+"')");
		res = twitbin.dbtwitbin.query("UPDATE temp_tweets SET favorited=1 WHERE (tweet_id='"+tweet_id+"' and twitbin_user_screen_name='"+user_screen_name+"')");
	},

	//-----------

	remTweetOfFavorites: function remTweetOfFavorites(tweet_id){
		if(!twitbin.userLogged()){ return false; }

		if (twitbin.viewController.viewCurrent == 'Favorite') {
			twitbin.viewController.viewInterface.deleteBoxTweet(tweet_id);
		}
		twitbin.utils.callHandler({"f1":"removeOfFavorites","p1":[tweet_id],"f2":"twitbin.updateTweetAsNotFavorite","p2":[tweet_id]},'twitter');
	},

	updateTweetAsNotFavorite: function updateTweetAsNotFavorite(tweet_id){
		if(!twitbin.userLogged()){ return false; }

		var res,
		user_screen_name = this.getLoggedUserName();

		res = twitbin.dbtwitbin.query("UPDATE tweets SET favorited=0 WHERE (tweet_id='"+tweet_id+"' and twitbin_user_screen_name='"+user_screen_name+"')");
		res = twitbin.dbtwitbin.query("UPDATE temp_tweets SET favorited=0 WHERE (tweet_id='"+tweet_id+"' and twitbin_user_screen_name='"+user_screen_name+"')");

		//TODO: verificar que si se esta viendo el tab de favoritos lo elimine de la lista
	},

	//-----------

	copyToClipboard: function copyToClipboard(text){
		if(!twitbin.userLogged()){ return false; }

		twitbin.gClipboardHelper.copyString(text);
	},

	pasteClipboard: function pasteClipboard(){
        if(!twitbin.userLogged()){ return false; }

		var clip,trans,str,strLength;
        clip = Components.classes["@mozilla.org/widget/clipboard;1"].getService(Components.interfaces.nsIClipboard);
        if (!clip) return false;

        trans = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
        if (!trans) return false;
        trans.addDataFlavor("text/unicode");

        clip.getData(trans, clip.kGlobalClipboard);

        str = new Object();
        strLength = new Object();

        trans.getTransferData("text/unicode", str, strLength);
        if (str) {
          str = str.value.QueryInterface(Components.interfaces.nsISupportsString);
          pastetext = str.data.substring(0, strLength.value / 2);
          return pastetext;
        }

        return false;
    },

    insertAtCursor: function insertAtCursor(myField, myValue) {

        if (document.getElementById(myField).selectionStart || document.getElementById(myField).selectionStart == '0') {
            var startPos = document.getElementById(myField).selectionStart,
            endPos = document.getElementById(myField).selectionEnd;
            document.getElementById(myField).value = document.getElementById(myField).value.substring(0, startPos)
            + myValue
            + document.getElementById(myField).value.substring(endPos, document.getElementById(myField).value.length);
        } else {
            $("#" + myField).val( $("#" + myField).val() + myValue );
        }
    },
//--------------------------------------------
//	  TIMELINE && MENTIONS
//--------------------------------------------

	loadTimeLineTweets: function loadTimeLineTweets(){
		if(!twitbin.userLogged()){ return false; }

		var last_tweet_id = this.getLastTweetId('TimeLine');
		if(last_tweet_id == false){ last_tweet_id = ''; }

		twitbin.utils.callHandler({"f1":"getTimeLineTweets","p1":[last_tweet_id],"f2":"twitbin.saveAndShowTweets","p2":['TimeLine']},'twitter');
	},

	loadMentionsTweets: function loadMentionsTweets(){
		if(!twitbin.userLogged()){ return false; }

		var last_tweet_id = this.getLastTweetId('Mentions');
		if(last_tweet_id == false){ last_tweet_id = ''; }

		twitbin.utils.callHandler({"f1":"getMentions","p1":[last_tweet_id],"f2":"twitbin.saveAndShowTweets","p2":['Mentions']},'twitter');
	},

	saveAndShowTweets: function saveAndShowTweets(type, tweets){
		if(!twitbin.userLogged()){ return false; }

		if(typeof(tweets.error)!="undefined"){
			twitbin.viewController.viewInterface.waitPage("hide");
			if(type == 'TimeLine' && twitbin.onInitSession ){
				twitbin.viewController.viewInterface.messageForLogin('show');
				twitbin.logOut();
			}
			return false;
		}

		twitbin.correctLogin = true;

		//save Twits on DB
		this.saveTweets(type, tweets);

		//Show time line or refresh view
		if(type == 'TimeLine' && twitbin.onInitSession ){
			twitbin.viewController.showTimeLineTweets();
			twitbin.onInitSession = false;//se indica que ya se inicio la sesion
		}else if (type == 'TimeLine'){
			twitbin.viewController.refresh('TimeLine',tweets.length);
		}else if(type == 'Mentions'){
			twitbin.viewController.refresh('Mentions',tweets.length);
		}
	},

	saveTweets: function saveTweets(type, tweets){
		if(!twitbin.userLogged()){ return false; }

		var i,url,d,fav,retweeted_by,user_screen_name,RT;

		for(i=0;i<tweets.length;i++){

			user_screen_name = this.getLoggedUserName();
			RT = tweets[i].retweeted_status;
			if(typeof(RT)!="undefined"){//En el caso de que sea un RT
				url = "http://twitter.com/#!/"+tweets[i].retweeted_status.user.screen_name+"/status/"+tweets[i].id_str;
				d= Date.parse(tweets[i].created_at);
				fav = 0;
				if(tweets[i].retweeted_status.favorited){
					fav = 1;
				}
				if(type == 'Public'){
					//																																																																																																																															tweet_id, 													twitbin_user_screen_name,created, 					text, 																														source, 										favorited, 				retweeted_by, 								retweet_id, 												owner_id, 															owner_screen_name, 																			image , 																url, 													in_reply_to_status_id, 									in_reply_to_screen_name, 															type_tweet
					this.dbtwitbin.query("insert into temp_tweets (tweet_id, twitbin_user_screen_name, created, text, source, favorited, retweeted_by, retweet_id, owner_id, owner_screen_name, image , url, in_reply_to_status_id, in_reply_to_screen_name, type_tweet) values ('"+tweets[i].retweeted_status.id_str+"','"+user_screen_name+"','"+d+"','"+twitbin.encript.rawEncode(tweets[i].retweeted_status.text)+"','"+tweets[i].retweeted_status.source+"','"+fav+"','"+tweets[i].user.screen_name+"', '"+tweets[i].id_str+"','"+tweets[i].retweeted_status.user.id_str+"','"+tweets[i].retweeted_status.user.screen_name+"','"+tweets[i].retweeted_status.user.profile_image_url+"','"+url+"','"+tweets[i].retweeted_status.in_reply_to_status_id_str+"','"+tweets[i].retweeted_status.in_reply_to_screen_name+"','"+type+"')");
				}else{
					this.dbtwitbin.query("insert into tweets (tweet_id, twitbin_user_screen_name, created, text, source, favorited, retweeted_by, retweet_id, owner_id, owner_screen_name, image , url, in_reply_to_status_id, in_reply_to_screen_name, type_tweet) values ('"+tweets[i].retweeted_status.id_str+"','"+user_screen_name+"','"+d+"','"+twitbin.encript.rawEncode(tweets[i].retweeted_status.text)+"','"+tweets[i].retweeted_status.source+"','"+fav+"','"+tweets[i].user.screen_name+"', '"+tweets[i].id_str+"','"+tweets[i].retweeted_status.user.id_str+"','"+tweets[i].retweeted_status.user.screen_name+"','"+tweets[i].retweeted_status.user.profile_image_url+"','"+url+"','"+tweets[i].retweeted_status.in_reply_to_status_id_str+"','"+tweets[i].retweeted_status.in_reply_to_screen_name+"','"+type+"')");
				}
			}else{//en el caso de que no sea un RT
				url = "http://twitter.com/#!/"+tweets[i].user.screen_name+"/status/"+tweets[i].id_str;
				d= Date.parse(tweets[i].created_at);
				fav = 0;
				if(tweets[i].favorited){
					fav = 1;
				}
				retweeted_by = 'null';
				if(tweets[i].user['protected']){
					retweeted_by = 'protected';
				}
				if(type == 'Public'){
					//																																																																																																																															tweet_id, 					twitbin_user_screen_name,created, 							text, 																source, 		favorited,				retweeted_by,retweet_id, 		owner_id, 									owner_screen_name, 												image, 										url,						in_reply_to_status_id,										in_reply_to_screen_name,				type_tweet
					this.dbtwitbin.query("insert into temp_tweets (tweet_id, twitbin_user_screen_name, created, text, source, favorited, retweeted_by, retweet_id, owner_id, owner_screen_name, image , url, in_reply_to_status_id, in_reply_to_screen_name, type_tweet) values ('"+tweets[i].id_str+"','"+user_screen_name+"','"+d+"','"+twitbin.encript.rawEncode(tweets[i].text)+"','"+tweets[i].source.replace("'","&#39;")+"','"+fav+"','"+retweeted_by+"','null','"+tweets[i].user.id_str+"','"+tweets[i].user.screen_name+"','"+tweets[i].user.profile_image_url+"','"+url+"','"+tweets[i].in_reply_to_status_id_str+"','"+tweets[i].in_reply_to_screen_name+"','"+type+"')");
				}else{
					this.dbtwitbin.query("insert into tweets (tweet_id, twitbin_user_screen_name, created, text, source, favorited, retweeted_by, retweet_id, owner_id, owner_screen_name, image , url, in_reply_to_status_id, in_reply_to_screen_name, type_tweet) values ('"+tweets[i].id_str+"','"+user_screen_name+"','"+d+"','"+twitbin.encript.rawEncode(tweets[i].text)+"','"+tweets[i].source.replace("'","&#39;")+"','"+fav+"','"+retweeted_by+"','null','"+tweets[i].user.id_str+"','"+tweets[i].user.screen_name+"','"+tweets[i].user.profile_image_url+"','"+url+"','"+tweets[i].in_reply_to_status_id_str+"','"+tweets[i].in_reply_to_screen_name+"','"+type+"')");
				}
			}
		}
	},

	getLastTweetId: function getLastTweetId(type_tweet){
		if(!twitbin.userLogged()){ return false; }

		var res,tweet_id,
		user_screen_name = this.getLoggedUserName();

		res = twitbin.dbtwitbin.query("SELECT tweet_id,retweeted_by,retweet_id  FROM tweets WHERE ( type_tweet = '"+type_tweet+"' and twitbin_user_screen_name = '"+user_screen_name+"') ORDER BY created DESC LIMIT 1");

		if(typeof(res[0])=="undefined"){ return false; }
			
		if((res[0].retweeted_by != 'null')&&(res[0].retweeted_by != 'protected')){
			//si es un retweet entonces retorno el id del retweet
			tweet_id = res[0].retweet_id;
		}else{
			//si no es un retweet entonces retorno el id del tweet
			tweet_id = res[0].tweet_id;
		}
		return tweet_id;
	},

//--------------------------------------------
//	  RETWEETS
//--------------------------------------------

	//synchronize with twitter my retweeted twees

	synchronizeRetweetedByMe: function (){
		if(!twitbin.userLogged()){ return false; }

		//busco los tweets retweeteados por el usuario para desmarcarlos
		var res,
		user_screen_name = this.getLoggedUserName();

		res = twitbin.dbtwitbin.query("SELECT tweet_id FROM tweets WHERE (retweeted_by = '"+user_screen_name+"' and twitbin_user_screen_name='"+user_screen_name+"')");
		if(typeof(res[0])!="undefined"){
			twitbin.markAsNotRetweetedByMe(res);
		}
		//ahora pido a twitter todos los retweeteados por el usuario para marcarlos en la DB.
		twitbin.LoadRetweetedByMe(1);//comienzo a pedir desde la pagina 1
	},

	markAsNotRetweetedByMe: function markAsNotRetweetedByMe(tweets){//el parametro es una respuesta a una consulta a la DB.
		if(!twitbin.userLogged()){ return false; }

		var i;

		for(i=0;i<tweets.length;i++){
			twitbin.updateTweetAsNotRetweeted(tweets[i].tweet_id);
		}
	},

	LoadRetweetedByMe: function LoadRetweetedByMe(page){
		if(!twitbin.userLogged()){ return false; }

		if(typeof(page)!="undefined"){
			twitbin.utils.callHandler({"f1":"getRetweetedByMe","p1":[parseInt(page)],"f2":"twitbin.saveObtainedRetweetedByMe","p2":[page]},'twitter');
		}
	},

	saveObtainedRetweetedByMe: function saveObtainedRetweetedByMe(page,retweeted){
		if(!twitbin.userLogged()){ return false; }

		if(retweeted.length > 0){
			twitbin.saveRetweetedByMe(retweeted);
			page++;
			twitbin.LoadRetweetedByMe(page);
		}
	},

	saveRetweetedByMe: function saveRetweetedByMe(tweets){
		if(!twitbin.userLogged()){ return false; }

		var i;

		for(i=0;i<tweets.length;i++){
			twitbin.updateTweetAsRetweetedByMe(tweets[i].retweeted_status.id_str,tweets[i].id_str)
		}
	},

//--------------------------------------------
//	 FAVORITES
//--------------------------------------------

	//synchronize with twitter my favorited twees

	synchronizeFavorites: function (){
		if(!twitbin.userLogged()){ return false; }

		//busco los tweets favoritos para poder marcarlos como no favoritos
		var res,
		user_screen_name = this.getLoggedUserName();

		res = twitbin.dbtwitbin.query("SELECT tweet_id FROM tweets WHERE (favorited = 1 and twitbin_user_screen_name='"+user_screen_name+"')");
		if(typeof(res[0])!="undefined"){
			twitbin.markAsNotFavorite(res);
		}

		//ahora pido a twitter todos los favoritos para marcarlos en la DB.
		twitbin.loadFavoriteTweets(1);//comienzo a pedir desde la pagina 1
	},

	markAsNotFavorite: function markAsNotFavorite(tweets){
		if(!twitbin.userLogged()){ return false; }

		var i;

		for(i=0;i<tweets.length;i++){
			twitbin.updateTweetAsNotFavorite(tweets[i].tweet_id);
		}
	},

	loadFavoriteTweets: function loadFavoriteTweets(page){
		if(!twitbin.userLogged()){ return false; }

		if(typeof(page)!="undefined"){
			twitbin.utils.callHandler({"f1":"getFavorites","p1":[parseInt(page)],"f2":"twitbin.saveObtainedFavorites","p2":[page]},'twitter');
		}
	},

	saveObtainedFavorites: function saveObtainedFavorites(page,favorites){
		if(!twitbin.userLogged()){ return false; }

		if(favorites.length > 0){
			twitbin.saveFavoritesTweets(favorites);
			page++;
			twitbin.loadFavoriteTweets(page);
		}
	},

	saveFavoritesTweets: function saveFavoritesTweets(tweets){
		if(!twitbin.userLogged()){ return false; }

		var i;

		for(i=0;i<tweets.length;i++){
			twitbin.updateTweetAsFavorite(tweets[i].id_str)
		}
	},

//--------------------------------------------
//	 DM
//--------------------------------------------

	//--------

	directMessages_allows: function directMessages_allows(screen_name_b,recipient_id){
		if(!twitbin.userLogged()){ return false; }

		var screen_name_a;

		if ( twitbin.twitter.isConfirmedFDM(recipient_id)) {
			twitbin.afterDirectMessages_allows(screen_name_b, recipient_id, true);
		} else{
			screen_name_a = this.getLoggedUserName();
			twitbin.utils.callHandler({"f1":"hasFriendship","p1":[screen_name_a,screen_name_b],"f2":"twitbin.directMessages_allows_step_two","p2":[screen_name_a,screen_name_b,recipient_id]},'twitter');
		}
	},

	directMessages_allows_step_two: function directMessages_allows_step_two(screen_name_a,screen_name_b,recipient_id,response){
		if(!twitbin.userLogged()){ return false; }

		if(typeof(response.error)!="undefined"){
			twitbin.viewController.viewInterface.cancelDMUser();
			this.showErrorMessage(response.error);
			return false;
		}

		if(!response){
			this.showErrorMessage("You can't send a direct message to this user");
			twitbin.viewController.viewInterface.cancelDMUser();
			return false;
		}

		twitbin.utils.callHandler({"f1":"hasFriendship","p1":[screen_name_b,screen_name_a],"f2":"twitbin.afterDirectMessages_allows","p2":[screen_name_b,recipient_id]},'twitter');
	},

	afterDirectMessages_allows: function afterDirectMessages_allows(recipient_name,recipient_id,response){
		if(!twitbin.userLogged()){ return false; }

		if(typeof(response.error)!="undefined"){
			twitbin.viewController.viewInterface.cancelDMUser();
			this.showErrorMessage(response.error);
			return false;
		}

		if(!response){
			twitbin.viewController.viewInterface.cancelDMUser();
			this.showErrorMessage("You can't send direct messages to this user");
			return false;
		}
		//guardo el usuario como ya verificado en esta session
		twitbin.twitter.confirmFDM(recipient_id);

		//muestro el textarea para enviar el mensaje directo
		twitbin.cookie.create('DM_recipient_id',recipient_id);
		twitbin.cookie.create('DM_recipient_name',recipient_name);
		twitbin.viewController.viewInterface.cancelDMUser();
		twitbin.viewController.viewInterface.openDM();
	},

	//--------

	LoadDirectMessages: function LoadDirectMessages(){
		if(!twitbin.userLogged()){ return false; }
		
		var last_dm_id = this.getLastDirectMessageId('receive');

		if(last_dm_id == false){
			twitbin.utils.callHandler({"f1":"getDirectMessages","p1":[""],"f2":"twitbin.saveAndShowDirectMessages","p2":null},'twitter');
		}else{
			twitbin.utils.callHandler({"f1":"getDirectMessages","p1":[last_dm_id],"f2":"twitbin.saveAndShowDirectMessages","p2":null},'twitter');
		}
	},

	LoadDirectMessagesSent: function LoadDirectMessagesSent(){
		if(!twitbin.userLogged()){ return false; }
		
		var last_dm_id = this.getLastDirectMessageId('sent');

		if(last_dm_id == false){
			twitbin.utils.callHandler({"f1":"getDirectMessagesSent","p1":[""],"f2":"twitbin.saveAndShowDirectMessages","p2":null},'twitter');
		}else{
			twitbin.utils.callHandler({"f1":"getDirectMessagesSent","p1":[last_dm_id],"f2":"twitbin.saveAndShowDirectMessages","p2":null},'twitter');
		}
	},

	saveAndShowDirectMessages: function saveAndShowDirectMessages(direct_messages){
		if(!twitbin.userLogged()){ return false; }
		
		if(typeof(direct_messages.error)!="undefined"){
			//this.showErrorMessage(direct_messages.error);
			return false;
		}

		this.saveDirectMessages(direct_messages);
		twitbin.viewController.refresh('DM',direct_messages.length);
	},

	saveDirectMessages: function saveDirectMessages(direct_messages){
		if(!twitbin.userLogged()){ return false; }
		
		var i,d,
		user_screen_name = this.getLoggedUserName();

		if(typeof(direct_messages.error)!="undefined"){
			//this.showErrorMessage(direct_messages.error);
			return false;
		}
		
		for(i=0;i<direct_messages.length;i++){
			d = Date.parse(direct_messages[i].created_at);
			this.dbtwitbin.query("insert into direct_messages (direct_message_id,twitbin_user_screen_name, created, text, sender_id, sender_screen_name, sender_image, sender_url, recipient_id, recipient_screen_name, recipient_image, recipient_url) values ('"+direct_messages[i].id_str+"','"+user_screen_name+"','"+d+"','"+twitbin.encript.rawEncode(direct_messages[i].text)+"','"+direct_messages[i].sender.id_str+"','"+direct_messages[i].sender.screen_name+"','"+direct_messages[i].sender.profile_image_url+"','"+direct_messages[i].sender.url+"','"+direct_messages[i].recipient.id_str+"','"+direct_messages[i].recipient.screen_name+"','"+direct_messages[i].recipient.profile_image_url+"','"+direct_messages[i].recipient.url+"')");
		}
	},

	//--------

	sendDirectMessage: function sendDirectMessage(recipient_name,recipient_id,msg){
		if(!twitbin.userLogged()){ return false; }

		//report
		twitbin.reports.add('Session.sent_messages');

		twitbin.utils.callHandler({"f1":"sendDirectMessage","p1":[recipient_name,recipient_id,msg],"f2":"twitbin.afterSendDirectMessage","p2":[recipient_id]},'twitter');
	},

	afterSendDirectMessage: function afterSendDirectMessage(recipient_id, response){
		if(!twitbin.userLogged()){ return false; }

		if(typeof(response.error)!="undefined"){
			//quito el usuario como ya verificado en esta session
			twitbin.twitter.removeConfirmedFDM(recipient_id);

			this.showErrorMessage(response.error);
			return false;
		}

		this.showErrorMessage("the message was sent");
		setTimeout(function(){twitbin.LoadDirectMessagesSent();}, 1500);
	},

	//--------

	deleteDirectMessage: function deleteDirectMessage(DM_id){
		if(!twitbin.userLogged()){ return false; }
		
		twitbin.utils.callHandler({"f1":"deleteDirectMessage","p1":[DM_id],"f2":"twitbin.afterDeleteDirectMessage","p2":null},'twitter');
	},

	afterDeleteDirectMessage: function afterDeleteDirectMessage(response){
		if(!twitbin.userLogged()){ return false; }

		var user = twitbin.getLoggedUserName();

		if(typeof(response.error)!="undefined"){
			this.showErrorMessage(response.error);
			return false;
		}

		twitbin.dbtwitbin.query("DELETE FROM direct_messages WHERE ( twitbin_user_screen_name = '"+user+"' AND direct_message_id ='"+response.id_str+"')");
	},

	//--------

	getLastDirectMessageId: function getLastDirectMessageId(user){
		if(!twitbin.userLogged()){ return false; }
		
		var res,
		user_screen_name = this.getLoggedUserName();

		res = twitbin.dbtwitbin.query("SELECT direct_message_id  FROM direct_messages WHERE (recipient_id = '"+this.logedUser.twitter_id+"' and twitbin_user_screen_name = '"+user_screen_name+"') ORDER BY created DESC LIMIT 1");
		if(user === 'sent'){
			res = twitbin.dbtwitbin.query("SELECT direct_message_id  FROM direct_messages WHERE (sender_id = '"+this.logedUser.twitter_id+"' and twitbin_user_screen_name = '"+user_screen_name+"') ORDER BY created DESC LIMIT 1");
		}

		if(typeof(res[0])=="undefined"){ return false; }

		return res[0].direct_message_id;
	},

//--------------------------------------------
//	 LISTS ( refresh && show )
//--------------------------------------------

	//busca las listas guardadas en twitter
	// para actualizar los datos de nuestra DB
	// se realiza mediante scheduled job

	loadAllList: function loadAllList(){
		if(!twitbin.userLogged()){ return false; }

		var user_screen_name = this.getLoggedUserName();

		twitbin.utils.callHandler({"f1":"getLists","p1":[user_screen_name],"f2":"twitbin.saveAndShowLists","p2":null},'twitter');
	},

	saveAndShowLists: function saveAndShowLists(response){
		if(!twitbin.userLogged()){ return false; }

		if(typeof(response.error)!="undefined"){
			//this.showErrorMessage(response.error);
			return false;
		}

		this.saveLists(response);
	},

	saveLists: function saveLists(lists){
		if(!twitbin.userLogged()){ return false; }

		var i,
		user_screen_name = this.getLoggedUserName();

		twitbin.deleteLists();
		for(i=0; i<lists.length;i++){
			twitbin.dbtwitbin.query("insert into lists (list_id,twitbin_user_screen_name, name, owner_screen_name, owner_id) values ('"+lists[i].id_str+"','"+user_screen_name+"','"+lists[i].full_name+"','"+lists[i].user.screen_name+"','"+lists[i].user.id_str+"')");
		}
	},

	// busca y carga nuevos twits de una lista en particular
	// luego se mustran en pantalla

	loadTweetsOfList: function loadTweetsOfList(list_id){
		if(!twitbin.userLogged()){ return false; }

		var last_tweet_id = this.getLastTweetListId(list_id);

		if(last_tweet_id == false){ last_tweet_id = ''; }

		twitbin.utils.callHandler({"f1":"getListTweets","p1":[list_id,last_tweet_id],"f2":"twitbin.saveAndShowTweetsList","p2":[list_id]},'twitter');
	},

	saveAndShowTweetsList: function saveAndShowTweetsList(list_id, tweets){
		if(!twitbin.userLogged()){ return false; }

		if(typeof(tweets.error)!="undefined") {
			this.viewController.viewInterface.waitPage('hide');
			this.showErrorMessage('Twitter isn\'t responding');
			return false;
		}

		twitbin.saveTweetsList(list_id, tweets);
		twitbin.removeMostOldsOfLists(list_id,twitbin.maxTweetOfLists);
		if(twitbin.viewController.viewCurrent != 'list_tweets'  || twitbin.viewController.viewTweetsOfListCurrent != list_id) {
            twitbin.viewController.showTweetsOfLists(list_id);
        }else{
            twitbin.viewController.appendNewTweetsOfLists(list_id);
        }
	},

	saveTweetsList: function saveTweetsList(list_id, tweets){
		if(!twitbin.userLogged()){ return false; }

		var i,user_screen_name,RT,url,d,fav,retweeted_by;

		for(i=0;i<tweets.length;i++){
			user_screen_name = this.getLoggedUserName();
			RT = tweets[i].retweeted_status;
			if(typeof(RT)!="undefined"){
				//En el caso de que sea un RT
				url = "http://twitter.com/#!/"+tweets[i].retweeted_status.user.screen_name+"/status/"+tweets[i].id_str;
				d = Date.parse(tweets[i].created_at);
				fav=0;
				if(tweets[i].retweeted_status.favorited){ fav = 1; }
				this.dbtwitbin.query("insert into tweets (tweet_id, twitbin_user_screen_name, created, text, source, favorited, retweeted_by, retweet_id, owner_id, owner_screen_name, image , url, in_reply_to_status_id, in_reply_to_screen_name, type_tweet) values ('"+tweets[i].retweeted_status.id_str+"','"+user_screen_name+"','"+d+"','"+twitbin.encript.rawEncode(tweets[i].retweeted_status.text)+"','"+tweets[i].retweeted_status.source+"','"+fav+"','"+tweets[i].user.screen_name+"', '"+tweets[i].id_str+"','"+tweets[i].retweeted_status.user.id_str+"','"+tweets[i].retweeted_status.user.screen_name+"','"+tweets[i].retweeted_status.user.profile_image_url+"','"+url+"','"+tweets[i].retweeted_status.in_reply_to_status_id_str+"','"+tweets[i].retweeted_status.in_reply_to_screen_name+"','TweetList')");
				this.dbtwitbin.query("insert into tweet_lists (twitbin_user_screen_name, list_id, tweet_id) values ('"+user_screen_name+"','"+list_id+"','"+tweets[i].retweeted_status.id_str+"')");
			}else{
				//en el caso de que no sea un RT
				url = "http://twitter.com/#!/"+tweets[i].user.screen_name+"/status/"+tweets[i].id_str;
				d = Date.parse(tweets[i].created_at);
				fav=0;
				if(tweets[i].favorited){ fav = 1; }
				retweeted_by='null';
				if(tweets[i].user['protected']){ retweeted_by = 'protected'; }
				this.dbtwitbin.query("insert into tweets (tweet_id, twitbin_user_screen_name, created, text, source, favorited, retweeted_by, retweet_id, owner_id, owner_screen_name, image , url, in_reply_to_status_id, in_reply_to_screen_name, type_tweet) values ('"+tweets[i].id_str+"','"+user_screen_name+"','"+d+"','"+twitbin.encript.rawEncode(tweets[i].text)+"','"+tweets[i].source.replace("'","&#39;")+"','"+fav+"','"+retweeted_by+"','null','"+tweets[i].user.id_str+"','"+tweets[i].user.screen_name+"','"+tweets[i].user.profile_image_url+"','"+url+"','"+tweets[i].in_reply_to_status_id_str+"','"+tweets[i].in_reply_to_screen_name+"','TweetList')");
				this.dbtwitbin.query("insert into tweet_lists (twitbin_user_screen_name, list_id, tweet_id) values ('"+user_screen_name+"','"+list_id+"','"+tweets[i].id_str+"')");
			}
		}
	},

	removeMostOldsOfLists: function removeMostOldsOfLists(list_id,x_last){
		if(!twitbin.userLogged()){ return false; }

		var res,cant_tweets,cant,q,ids_tweets,
		user = twitbin.getLoggedUserName();

		res = twitbin.dbtwitbin.query("SELECT count(*) as cant_tweets FROM tweet_lists WHERE (twitbin_user_screen_name = '"+user+"'  AND list_id = '"+list_id+"')");
		if(typeof(res[0]) =="undefined"){ return false; }

		cant_tweets = res[0].cant_tweets;
		if(cant_tweets <= x_last) { return false; }

		cant = cant_tweets - x_last;
		q = "SELECT T.tweet_id tweet_id FROM (SELECT tweet_id FROM tweet_lists WHERE (twitbin_user_screen_name = '"+user+"'  AND list_id = '"+list_id+"')) L, (SELECT * FROM tweets WHERE (type_tweet = 'TweetList')) T WHERE T.tweet_id = L.tweet_id ORDER BY T.created ASC LIMIT "+cant;
		res = twitbin.dbtwitbin.query(q);

		ids_tweets = "('";
		for(var i=0;i<res.length;i++){
			if(i!=0){
				ids_tweets += "','"+res[i].tweet_id;
			}else{
				ids_tweets += res[i].tweet_id;
			}
		}
		ids_tweets +="')";

		twitbin.dbtwitbin.query("DELETE FROM tweets WHERE ( twitbin_user_screen_name = '"+user+"' AND tweet_id IN "+ids_tweets+")");
		twitbin.dbtwitbin.query("DELETE FROM tweet_lists WHERE ( twitbin_user_screen_name = '"+user+"' AND tweet_id IN "+ids_tweets+")");
	},

	//borra todas las listas de un usuario
	//cuando se borra un usuario || cuando se actualizan las listas

	deleteLists: function deleteLists(){
		if(!twitbin.userLogged()){ return false; }

		var user_screen_name = twitbin.getLoggedUserName();

		twitbin.dbtwitbin.query("delete from lists where twitbin_user_screen_name = '"+user_screen_name+"'");
	},

	//Obtiene el id del ultimo twit guardado para una lista

	getLastTweetListId: function getLastTweetListId(list_id){
		if(!twitbin.userLogged()){ return false; }

		var q,res,tweet_id,
		user_screen_name = this.getLoggedUserName();

		q = "SELECT T.tweet_id tweet_id, T.retweeted_by retweeted_by, T.retweet_id retweet_id FROM (SELECT tweet_id FROM tweet_lists WHERE (twitbin_user_screen_name = '"+user_screen_name+"' and list_id='"+list_id+"')) L, (SELECT * FROM tweets WHERE (type_tweet = 'TweetList')) T WHERE T.tweet_id = L.tweet_id ORDER BY T.created DESC LIMIT 1";
		res = twitbin.dbtwitbin.query(q);
		if(typeof(res[0]) =="undefined"){ return false; }

		if((res[0].retweeted_by != 'null')&&(res[0].retweeted_by != 'protected')){
			//si es un retweet entonces retorno el id del retweet
			tweet_id = res[0].retweet_id;
		}else{
			//si no es un retweet entonces retorno el id del tweet
			tweet_id = res[0].tweet_id;
		}

		return tweet_id;
	},

//--------------------------------------------
//	 SEARCHES ( refresh && show )
//--------------------------------------------

	//busca los searches guardados en twitter
	// para actualizar los datos de nuestra DB
	// se realiza mediante scheduled job

	loadAllSearches: function loadAllSearches(){
		if(!twitbin.userLogged()){ return false; }

		twitbin.utils.callHandler({"f1":"getSavedSearch","p1":null,"f2":"twitbin.saveAndShowSearches","p2":null},'twitter');
	},

	saveAndShowSearches: function saveAndShowSearches(searches){
		if(!twitbin.userLogged()){ return false; }

		if(typeof(searches.error)!="undefined"){
			return false;
			//ESTO ES INTERNO Y NO DEBERIA INFORMAR ERRORES
			//this.showErrorMessage(searches.error);
		}

		this.saveSearches(searches);
	},

	saveSearches: function saveSearches(searches){
		if(!twitbin.userLogged()){ return false; }

		var i,
		user_screen_name = this.getLoggedUserName();

		twitbin.deleteSearches();
		for(i=0; i<searches.length;i++){
			twitbin.dbtwitbin.query("insert into searches (twitbin_user_screen_name, search_id, name, query) values ('"+user_screen_name+"','"+searches[i].id_str+"','"+searches[i].name+"','"+searches[i].query+"')");
		}
	},

	//busca los twits de una busqueda guardada,
	//desde el ultimo registrado en la db o todos
	// en caso de que no haya ninguno guardado

	loadTweetsOfSavedSearch: function loadTweetsOfSavedSearch(search_id){
		if(!twitbin.userLogged()){ return false; }

		var q,res,
		last_tweet_id = this.getLastTweetSearchId(search_id);

		if(last_tweet_id == false){ last_tweet_id = '';}

		q = "SELECT * FROM searches WHERE (search_id = '"+search_id+"')";
		res = twitbin.dbtwitbin.query(q);

		twitbin.utils.callHandler({"f1":"search","p1":[twitbin.encript.rawEncode(res[0].query),last_tweet_id],"f2":"twitbin.saveAndShowTweetsOfsavedSearch","p2":[search_id]},'twitter');
	},

	saveAndShowTweetsOfsavedSearch: function saveAndShowTweetsOfsavedSearch(search_id, tweets){
		if(!twitbin.userLogged()){ return false; }

		if(typeof(tweets.error)!="undefined"){
			this.viewController.viewInterface.waitPage('hide');
			this.showErrorMessage('Twitter isn\'t responding');
			return false;
		}

		twitbin.saveTweetsOfSavedSearch(search_id, tweets);
		twitbin.removeMostOldsOfSearch(search_id,twitbin.maxTweetOfSearches);

		if(twitbin.viewController.viewCurrent != 'search_tweets'  || twitbin.viewController.viewTweetsOfSearchCurrent != search_id) {
		    twitbin.viewController.showTweetsOfSearches(search_id);
		}else{
		    twitbin.viewController.appendNewTweetsOfSearches(search_id);
		}
	},

	saveTweetsOfSavedSearch: function saveTweetsOfSavedSearch(search_id, founds){
		if(!twitbin.userLogged()){ return false; }

		var user_screen_name,url,d,
		tweets = founds.results,
		fav=0,
		retweeted_by='null';

		for(var i=0;i<tweets.length;i++){

			user_screen_name = this.getLoggedUserName();
			url = "http://twitter.com/#!/"+tweets[i].from_user+"/status/"+tweets[i].id_str;
			d = Date.parse(tweets[i].created_at);

			this.dbtwitbin.query("insert into tweets (tweet_id, twitbin_user_screen_name, created, text, source, favorited, retweeted_by, retweet_id, owner_id, owner_screen_name, image , url, in_reply_to_status_id, in_reply_to_screen_name, type_tweet) values ('"+tweets[i].id_str+"','"+user_screen_name+"','"+d+"','"+twitbin.encript.rawEncode(tweets[i].text)+"','"+tweets[i].source.replace("'","&#39;")+"','"+fav+"','"+retweeted_by+"','null','"+tweets[i].from_user_id+"','"+tweets[i].from_user+"','"+tweets[i].profile_image_url+"','"+url+"','"+tweets[i].to_user_id_str+"','null','TweetSearch')");
			this.dbtwitbin.query("insert into tweets_search (twitbin_user_screen_name, search_id, tweet_id) values ('"+user_screen_name+"','"+search_id+"','"+tweets[i].id_str+"')");
		}
	},

	removeMostOldsOfSearch: function removeMostOldsOfSearch(search_id,x_last){
		if(!twitbin.userLogged()){ return false; }

		var res,cant_tweets,cant,q,ids_tweets,
		user = twitbin.getLoggedUserName();

		res = twitbin.dbtwitbin.query("SELECT count(*) as cant_tweets FROM tweets_search WHERE (twitbin_user_screen_name = '"+user+"'  AND search_id = '"+search_id+"')");
		if(typeof(res[0]) =="undefined"){ return false; }

		cant_tweets = res[0].cant_tweets;
		if(cant_tweets <= x_last) { return false; }

		cant = cant_tweets - x_last;
		q = "SELECT T.tweet_id tweet_id FROM (SELECT tweet_id FROM tweets_search WHERE (twitbin_user_screen_name = '"+user+"'  AND search_id = '"+search_id+"')) S, (SELECT * FROM tweets WHERE (type_tweet = 'TweetSearch')) T WHERE T.tweet_id = S.tweet_id ORDER BY T.created ASC LIMIT "+cant;
		res = twitbin.dbtwitbin.query(q);

		ids_tweets = "('";
		for(var i=0;i<res.length;i++){
			if(i == 0){ ids_tweets += res[i].tweet_id; } else { ids_tweets += "','"+res[i].tweet_id; }
		}
		ids_tweets +="')";

		twitbin.dbtwitbin.query("DELETE FROM tweets WHERE ( twitbin_user_screen_name = '"+user+"' AND tweet_id IN "+ids_tweets+")");
		twitbin.dbtwitbin.query("DELETE FROM tweets_search WHERE ( twitbin_user_screen_name = '"+user+"' AND tweet_id IN "+ids_tweets+")");
	},

	//realiza una busqueda temporal
	//guarda los twits en una tabla temporal

	startTempSearch: function (query) {
		if(!twitbin.userLogged()){ return false; }

		if ($.trim(query) == '') { return false; }

		this.viewController.viewInterface.waitPage('show');
		this.loadTweetsOfSearch(query);
	},

	loadTweetsOfSearch: function loadTweetsOfSearch(query){
		if(!twitbin.userLogged()){ return false; }

		twitbin.utils.callHandler({"f1":"search","p1":[twitbin.encript.rawEncode(query),''],"f2":"twitbin.saveAndShowTweetsOfSearch","p2":null},'twitter');
	},

	saveAndShowTweetsOfSearch: function saveAndShowTweetsOfSearch(tweets){

		if(!twitbin.userLogged()){ return false; }

		if(typeof(tweets.error)!="undefined"){
			this.viewController.viewInterface.waitPage('hide');
			this.showErrorMessage('Twitter isn\'t responding');
			return false;
		}

		this.saveTweetsOfSearchInTemp(tweets);

		this.viewController.showSearches();
		this.viewController.showTempSearchTweets();
	},

	saveTweetsOfSearchInTemp: function saveTweetsOfSearchInTemp(founds){
		if(!twitbin.userLogged()){ return false; }

		var tweets,url,d,
		user_screen_name = this.getLoggedUserName();

		twitbin.dbtwitbin.query("DELETE FROM temp_tweets WHERE ( twitbin_user_screen_name = '"+user_screen_name+"' AND type_tweet = 'TweetSearch')");

		tweets = founds.results;
		for(var i=0;i<tweets.length;i++){

			url = "http://twitter.com/#!/"+tweets[i].from_user+"/status/"+tweets[i].id_str;
			d= Date.parse(tweets[i].created_at);
			try{
				this.dbtwitbin.query("insert into temp_tweets (tweet_id, twitbin_user_screen_name, created, text, source, favorited, retweeted_by, retweet_id, owner_id, owner_screen_name, image , url, in_reply_to_status_id, in_reply_to_screen_name, type_tweet) values ('"+tweets[i].id_str+"','"+user_screen_name+"','"+d+"','"+twitbin.encript.rawEncode(tweets[i].text)+"','"+tweets[i].source.replace("'","&#39;")+"','0','null','null','"+tweets[i].from_user_id+"','"+tweets[i].from_user+"','"+tweets[i].profile_image_url+"','"+url+"','"+tweets[i].to_user_id_str+"','null','TweetSearch')");
			}catch(e){
			}
		}
	},

	//Guarda una busqueda temporal

	saveTempSearch: function saveThisSearch(query, name){
		if(!twitbin.userLogged()){ return false; }

		if(typeof(name) =="undefined"){
			name = query;
		}

		//report
		twitbin.reports.add('Session.saved_searches');

		twitbin.utils.callHandler({"f1":"saveSearch","p1":[query],"f2":"twitbin.afterSaveTempSearch","p2":[name]},'twitter');
	},

	afterSaveTempSearch: function saveSearch(name, search){
		if(!twitbin.userLogged()){ return false; }

		if(typeof(search.error)!="undefined"){
			// this.showErrorMessage(search.error);
			return false;
		}

		var respond,tweets,i,asearch,
		user_screen_name = this.getLoggedUserName();

		respond = twitbin.dbtwitbin.query("insert into searches (twitbin_user_screen_name, search_id, name, query) values ('"+user_screen_name+"','"+search.id_str+"','"+name+"','"+search.query+"')");
		tweets = this.dbtwitbin.query("SELECT * FROM temp_tweets WHERE (twitbin_user_screen_name = '"+user_screen_name+"' AND type_tweet = 'TweetSearch')");

		for(i=0;i<tweets.length;i++){
			this.dbtwitbin.query("insert into tweets (tweet_id, twitbin_user_screen_name, created, text, source, favorited, retweeted_by, retweet_id, owner_id, owner_screen_name, image , url, in_reply_to_status_id, in_reply_to_screen_name, type_tweet) values ('"+tweets[i].tweet_id+"','"+tweets[i].twitbin_user_screen_name+"','"+tweets[i].created+"','"+tweets[i].text+"','"+tweets[i].source.replace("'","&#39;")+"','"+tweets[i].favorited+"','"+tweets[i].retweeted_by+"', '"+tweets[i].retweet_id+"','"+tweets[i].owner_id+"','"+tweets[i].owner_screen_name+"','"+tweets[i].image+"','"+tweets[i].url+"','"+tweets[i].in_reply_to_status_id+"','"+tweets[i].in_reply_to_screen_name+"','TweetSearch')");
			this.dbtwitbin.query("insert into tweets_search (twitbin_user_screen_name, search_id, tweet_id) values ('"+user_screen_name+"','"+search.id_str+"','"+tweets[i].tweet_id+"')");
		}

		asearch = this.dbtwitbin.query("SELECT * FROM searches WHERE id = " + respond + " LIMIT 1");
		twitbin.viewController.addNewSearch( asearch[0].search_id, asearch[0].name );
	},

	//borra una busqueda en particular

	deleteSearch: function deleteSearch(search_id){
		if(!twitbin.userLogged()){ return false; }

		twitbin.utils.callHandler({"f1":"deleteSearch","p1":[search_id],"f2":"twitbin.afterDeleteSearch","p2":null},'twitter');
	},

	afterDeleteSearch: function afterDeleteSearch(response){
		if(!twitbin.userLogged()){ return false; }

		if(typeof(response.error)!="undefined"){
			//	this.showErrorMessage(response.error);
			return false;
		}

		var q,res,ids_tweets,
		user_screen_name = this.getLoggedUserName();

		q = "SELECT T.tweet_id tweet_id FROM (SELECT tweet_id FROM tweets_search WHERE (twitbin_user_screen_name = '"+user_screen_name+"' and search_id='"+response.id_str+"')) S, (SELECT * FROM tweets WHERE (type_tweet = 'TweetSearch')) T WHERE T.tweet_id = S.tweet_id ORDER BY T.tweet_id";
		res = twitbin.dbtwitbin.query(q);

		ids_tweets = "('";
		for(var i=0;i<res.length;i++){
			if(i!=0){
				ids_tweets += "','"+res[i].tweet_id;
			}else{
				ids_tweets += res[i].tweet_id;
			}
		}
		ids_tweets +="')";

		twitbin.dbtwitbin.query("DELETE FROM tweets WHERE ( twitbin_user_screen_name = '"+user_screen_name+"' AND tweet_id IN "+ids_tweets+")");
		twitbin.dbtwitbin.query("DELETE FROM searches WHERE ( twitbin_user_screen_name = '"+user_screen_name+"' AND search_id ='"+response.id_str+"')");
		twitbin.dbtwitbin.query("DELETE FROM tweets_search WHERE ( twitbin_user_screen_name = '"+user_screen_name+"' AND search_id ='"+response.id_str+"')");
	},


	//borra todas las busquedas
	//cuando se borra un usuario || cuando se actualizan las busquedas

	deleteSearches: function deleteSearches(){
		if(!twitbin.userLogged()){ return false; }

		var user_screen_name = twitbin.getLoggedUserName();

		twitbin.dbtwitbin.query("DELETE FROM searches WHERE twitbin_user_screen_name = '"+user_screen_name+"'");
	},

	// obtiene el id del ultimo twit guardado

	getLastTweetSearchId: function getLastTweetSearchId(search_id){
		if(!twitbin.userLogged()){ return false; }

		var q,res,
		user_screen_name = this.getLoggedUserName();

		q = "SELECT T.tweet_id tweet_id FROM (SELECT tweet_id FROM tweets_search WHERE (twitbin_user_screen_name = '"+user_screen_name+"' and search_id='"+search_id+"')) S, (SELECT * FROM tweets WHERE (type_tweet = 'TweetSearch')) T WHERE T.tweet_id = S.tweet_id ORDER BY T.created DESC LIMIT 1";
		res = twitbin.dbtwitbin.query(q);

		if(typeof(res[0])=="undefined"){ return false; }

		return res[0].tweet_id;
	},

	// checkea si el query pasado ya es una busqueda guardada

	is_a_savedSearch: function is_a_savedSearch(query, query_is_id){
		if(!twitbin.userLogged()){ return false; }

		var res,
		user_screen_name = this.getLoggedUserName();

		if (query_is_id){
			res = twitbin.dbtwitbin.query("SELECT query FROM searches WHERE search_id='"+query+"' AND twitbin_user_screen_name='"+user_screen_name+"'");
		}else{
			res = twitbin.dbtwitbin.query("SELECT query FROM searches WHERE query='"+query+"' AND twitbin_user_screen_name='"+user_screen_name+"'");
		}

		if(typeof(res[0])!="undefined"){ return false; }

		return true;
	},

//--------------------------------------------
//	 PUBLIC TIMELINE  ( refresh && show )
//--------------------------------------------

	loadPublicTweets: function loadPublicTweets(){
		twitbin.utils.callHandler({"f1":"getPublicTweets","p1":[""],"f2":"twitbin.saveAndShowPublicTweets","p2":null},'twitter');
	},

	saveAndShowPublicTweets: function saveAndShowPublicTweets(tweets){
		this.savePublicTweets(tweets);

		//si esta en iniciando twitbin mostraran los tweets publicos
		if(twitbin.onStart){
			twitbin.viewController.showPublicTweets();
			twitbin.onStart = false;//se indica que ya no se esta iniciando twitbin
		}
	},

	savePublicTweets: function savePublicTweets(tweets){
		var url,d,fav,retweeted_by,i,
		user_screen_name = this.getLoggedUserName();
		for(i=0;i<tweets.length;i++){

			url = "http://twitter.com/#!/"+tweets[i].user.screen_name+"/status/"+tweets[i].id_str;
			d= Date.parse(tweets[i].created_at);
			fav = 0;
			if(tweets[i].favorited){ fav = 1; }
			retweeted_by = 'null';
			if(tweets[i].user['protected']){ retweeted_by = 'protected'; }

			this.dbtwitbin.query("insert into temp_tweets (tweet_id, twitbin_user_screen_name, created, text, source, favorited, retweeted_by, retweet_id, owner_id, owner_screen_name, image , url, in_reply_to_status_id, in_reply_to_screen_name, type_tweet) values ('"+tweets[i].id_str+"','"+user_screen_name+"','"+d+"','"+twitbin.encript.rawEncode(tweets[i].text)+"','"+tweets[i].source.replace("'","&#39;")+"','"+fav+"','"+retweeted_by+"','null','"+tweets[i].user.id_str+"','"+tweets[i].user.screen_name+"','"+tweets[i].user.profile_image_url+"','"+url+"','"+tweets[i].in_reply_to_status_id_str+"','"+tweets[i].in_reply_to_screen_name+"','Public')");
		}
	},

//--------------------------------------------
//	 SHORT URL
//--------------------------------------------

	ShortenURL: function ShortenURL(tweet,url,action){
		if(!twitbin.userLogged()){ return false; }

		twitbin.reports.add('Session.links');
		twitbin.utils.callHandler({"f1":"short","p1":[url],"f2":"twitbin.afterShortenURL","p2":[tweet,url,action]},'shortenUrl');
	},

	afterShortenURL: function afterShortenURL(tweet,url,action,response){
		if(!twitbin.userLogged()){ return false; }
		
		var DM,image_url,msg,DM_recipient_name,DM_recipient_id;

		if(action == 'change'){
			tweet = twitbin.viewController.viewInterface.getTweetTextarea();
			twitbin.viewController.viewInterface.setTweetTextarea(tweet.replace(url,response));
		}else if(action == 'changeDM'){
			DM = twitbin.viewController.viewInterface.getDMTextarea();
			twitbin.viewController.viewInterface.setDMTextarea(DM.replace(url,response));
		}else if(action == 'post'){
			tweet = tweet.replace(url,response);

			if(twitbin.cookie.exist("image_attached")){//si hay una imagen cargada
				if(twitbin.mediaUploader.uploader != "pikchur"){
					//vuelvo a setear el tweet para que postphoto lo tome.
					twitbin.viewController.viewInterface.setTweetTextarea(tweet);
					//si la imagen se envia por twitter
					twitbin.postPhoto();//hago el tweet por medio de la funcion postPhoto.
					twitbin.viewController.viewInterface.cancelTweet();//contrae el textarea y elimina las cookies
				}else{
					//si la imagen se envia por pikchur. entonces la imagen ya se envio y solo queda concatenar la imagen
					image_url = twitbin.cookie.read("image_attached");//leo la url de la imagen.
					tweet = tweet+" "+image_url;//concateno la imagen al tweet.
					twitbin.updateStatus(tweet);//hago el tweet.
					twitbin.viewController.viewInterface.cancelTweet();//contrae el textarea y elimina las cookies
				}
			}else{
				twitbin.updateStatus(tweet);//hago el tweet.
				twitbin.viewController.viewInterface.cancelTweet();//contrae el textarea y elimina las cookies
			}

		}else if(action == 'sendDM'){
			DM_recipient_id = twitbin.cookie.read('DM_recipient_id');
			DM_recipient_name = twitbin.cookie.read('DM_recipient_name');
			msg = twitbin.cookie.read('DM_msg');

			twitbin.sendDirectMessage(DM_recipient_name,DM_recipient_id,msg.replace(url,response));
			twitbin.cookie.remove('DM_recipient_id');
			twitbin.cookie.remove('DM_recipient_name');
			twitbin.cookie.remove('DM_msg');
			twitbin.viewController.viewInterface.cancelDM();
		}
	},

//--------------------------------------------
//	 POSTS IMAGE
//--------------------------------------------

	postPhoto: function postPhoto(){
		if(!twitbin.userLogged()){ return false; }

		if(twitbin.mediaUploader.uploader == "pikchur"){
			twitbin.viewController.viewInterface.waitPage("show");
			twitbin.viewController.viewInterface.setStatusSubmit("disabled");
			twitbin.showErrorMessage("wait until we load the image");

		}
		//twitbin.viewController.viewInterface.setInputFile("enabled");

		twitbin.mediaUploader.setForm(document.getElementById('form'));//seteo el form de tweets
		twitbin.reports.add('Session.pictures');

		if(twitbin.mediaUploader.uploader == "twitter"){//Si se envia la imagen por twitter
			//copio el texto del tweet al input text del form antes de enviar

			//si se esta haciendo un reply entonces tengo que obtener el id del tweet.
			if(twitbin.cookie.exist('in_reply_to_status_id')){
				var in_reply_to_status_id = '';
				in_reply_to_status_id = twitbin.cookie.read('in_reply_to_status_id');
				twitbin.reports.add('Session.replies');
				twitbin.cookie.remove('in_reply_to_status_id');
				$("#twitter_reply").val(in_reply_to_status_id);
			}
			$("#twitter_status").val(twitbin.viewController.viewInterface.getTweetTextarea());
		}

		twitbin.utils.callHandler({"f1":"sharePhoto","p1":["tweet"],"f2":"twitbin.afterPostPhoto","p2":null},'mediaUploader');
	},

	afterPostPhoto: function afterPostPhoto(response){
		if(!twitbin.userLogged()){
			//oculto la pantalla de wait
			twitbin.viewController.viewInterface.waitPage("hide");
			return false; 
		}
		//oculto la pantalla de wait
		twitbin.viewController.viewInterface.waitPage("hide");

		if(twitbin.mediaUploader.uploader == "pikchur"){
			if(response.status=="fail"){
				this.showErrorMessage("Sorry, we had trouble loading the image");
				return false;
			}

			twitbin.cookie.create("image_attached",response.mediaurl);
		}else{//si se envio la imagen a twitter.
			//recargo el timeline
			twitbin.loadTimeLineTweets();
		}
		twitbin.viewController.viewInterface.setStatusSubmit("enabled");
	},

	postPhotoDM: function postPhotoDM(){
		if(!twitbin.userLogged()){ return false; }

		twitbin.mediaUploader.setForm(document.getElementById('formDM'));//seteo el form de mensajes directos
		twitbin.utils.callHandler({"f1":"sharePhoto","p1":["DM"],"f2":"twitbin.afterPostPhotoDM","p2":null},'mediaUploader');
		twitbin.viewController.viewInterface.setDMSubmit("disabled");
		twitbin.viewController.viewInterface.notificationOnDM("show","wait until we load the image");
	},

	afterPostPhotoDM: function afterPostPhotoDM(response){
		if(!twitbin.userLogged()){ return false; }

		var tweet;

		if(response.status=="fail"){
			twitbin.viewController.viewInterface.notificationOnDM("show","Sorry, we had trouble loading the image");
			return false;
		}

		twitbin.viewController.viewInterface.notificationOnDM("hide","");
		tweet = twitbin.viewController.viewInterface.getDMTextarea();
		tweet += ' '+response.mediaurl + ' ';
		twitbin.viewController.viewInterface.setDMTextarea(tweet);
		twitbin.viewController.viewInterface.setDMSubmit("enabled");
	},

//--------------------------------------------
//	 MISC
//--------------------------------------------
	getConfiguration: function getConfiguration(){
		twitbin.utils.callHandler({"f1":"getConfiguration","p1":null,"f2":"twitbin.afterGetConfiguration","p2":null},'twitter');
	},

	afterGetConfiguration: function afterGetConfiguration(response){
		twitbin.http_short_url_length = response.short_url_length;
	},

	getPrefTimeRateOfUser: function getPrefTimeRateOfUser(){
		var q,res,
		user_screen_name = this.getLoggedUserName();

		q = "SELECT P.reload_rate reload_rate FROM (SELECT user_preferences FROM users WHERE (name = '"+user_screen_name+"')) U , (SELECT * FROM preferences WHERE 1) P WHERE P.id = U.user_preferences";
		res = twitbin.dbtwitbin.query(q);

		if(typeof(res[0])=="undefined"){ return false; }

		return parseInt(res[0].reload_rate);
	},

	getCurrentDateTime: function getCurrentDateTime(){
		var month,day,year,hours,minutes,seconds,date,
		currentTime = new Date();

		month = currentTime.getMonth() + 1;
		day = currentTime.getDate();
		year = currentTime.getFullYear();
		hours = currentTime.getHours();
		minutes = currentTime.getMinutes();
		seconds = currentTime.getSeconds();
		date = year +"-"+month +"-"+day+" "+hours+":"+minutes+":"+seconds;
		return date;
	},

	userLogged: function userLogged(){
		if(twitbin.logedUser == null){ return false; }
		return true;
	},

	/**
	 * Return the username of authenticated user
	 *
	 * @param ---
	 * @access public
	 */
	getLoggedUserName: function getLoggedUserName(){
		var user_screen_name = "anonymous";
		if(twitbin.logedUser != null){
			user_screen_name = twitbin.logedUser.screen_name;
		}
		return user_screen_name;
	},

	getLoggedUserId: function getLoggedUserId(){
		var user_id = false;
		if(twitbin.logedUser != null){
			user_id = twitbin.logedUser.twitter_id;
		}
		return user_id;
	},

	/**
	 * Return a user
	 *
	 * @param id of Twitbin user
	 * @access public
	 */
	getUser: function getUser(id){
		var res = this.dbtwitbin.query("select * FROM users WHERE id='"+id+"'");

		if(typeof(res[0])!="undefined"){ return res; }

		return false;
	},

	/**
	 * Return a user
	 *
	 * @param id of Twitbin user
	 * @access public
	 */
	getUsers: function getUsers(){
		var res = this.dbtwitbin.query("select name, id, profile_image FROM users");
		if(typeof(res[0])!="undefined"){
			return res;
		}
		return false;
	},

	getTweet: function getTweet(tweet_id){
		if(!twitbin.userLogged()){ return false; }

		var res,res_temp,
		user_screen_name = this.getLoggedUserName();

		res = twitbin.dbtwitbin.query("SELECT * FROM tweets WHERE (  twitbin_user_screen_name = '"+user_screen_name+"' and tweet_id='"+tweet_id+"')");
		res_temp = twitbin.dbtwitbin.query("SELECT * FROM temp_tweets WHERE (  twitbin_user_screen_name = '"+user_screen_name+"' and tweet_id='"+tweet_id+"')");
		if(typeof(res[0])!="undefined"){
			return res[0];
		}else if(typeof(res_temp[0])!="undefined"){
			return res_temp[0];
		}
		return false;
	},

	getDM: function getDM(dm_id){
		if(!twitbin.userLogged()){ return false; }

		var res,
		user_screen_name = this.getLoggedUserName();

		res = twitbin.dbtwitbin.query("SELECT * FROM direct_messages WHERE (  twitbin_user_screen_name = '"+user_screen_name+"' and direct_message_id='"+dm_id+"')");
		if(typeof(res[0])!="undefined"){
			return res[0];
		}
		return false;
	},

	functionsToExecuteOnInit: function functionsToExecuteOnInit(){
		if(!twitbin.cookie.exist("functions_on_init",true)){ return true; }

		var functions,jsonFunction,paramsString,params,i,j,
		functions_string = twitbin.cookie.read("functions_on_init",true);

		twitbin.cookie.remove("functions_on_init",true);

		functions = functions_string.split("||");

		for(i=0;i<functions.length;i++){
			jsonFunction = jQuery.parseJSON(functions[i]);

			//armo el arreglo de parametros nuevamente, porque me llega como un string
			paramsString = jsonFunction.p1.split(",");
			params = [];

			for(j=0;j<paramsString.length;j++){
				params.push(paramsString[j].toString());
			}

			//vuelvo a setear el arreglo de parametros bien formado
			jsonFunction.p1 = params;
			//llamo a la funcion
			twitbin.callback.execute(jsonFunction);
		}

		twitbin.onInitSession = false;
	},

	setFunctionToExecuteOnInit: function setFunctionToExecuteOnInit(functionToExec,params){

		//esta funcion deberia recibir un string con la funcion a ejecutar y ademas un arreglo con los parametros para la funcion.
		var functions,
		stringJSON = "{\"f1\":\""+functionToExec+"\",\"p1\":\""+params.toString()+"\"}";

		if(twitbin.cookie.exist("functions_on_init",true)){//en el caso de que ya haya otras funciones cargadas
			functions = twitbin.cookie.read("functions_on_init",true);
			twitbin.cookie.remove("functions_on_init",true);

			//aca en lugar de concatenar la funcion. lo que se deberia hacer es crear un json pero en forma de string y luego concatenarlo.
			functions += "||"+stringJSON;
		}else{
			functions = stringJSON;
		}

		twitbin.cookie.create("functions_on_init",functions);
	},

	savePreferences: function savePreferences(sidebar_position,image_uploader,reload_rate,secure,password){
		if(!twitbin.userLogged()){ return false; }

		var res,res1,
		user_screen_name = this.getLoggedUserName();

		res = twitbin.dbtwitbin.query("SELECT user_preferences, password FROM users WHERE (name = '"+user_screen_name+"')");
		if(typeof(res[0])=="undefined"){ return false; }

// 				twitbin.setImageUploader(image_uploader);
		res1 = twitbin.dbtwitbin.query("UPDATE users SET password = '' WHERE (name = '"+user_screen_name+"')");
		if(secure){//el usuario esta guardando una cuenta segura.
			if(twitbin.cookie.exist("password_on_pref")){
				password = res[0].password;
				twitbin.cookie.remove("password_on_pref");
			}
			res1 = twitbin.dbtwitbin.query("UPDATE users SET password = '"+password+"' WHERE (name = '"+user_screen_name+"')");
		}
		res = twitbin.dbtwitbin.query("UPDATE preferences SET reload_rate="+reload_rate+", sidebar_position ='"+sidebar_position+"', image_uploader ='"+image_uploader+"' WHERE(id = '"+res[0].user_preferences+"')");
		twitbin.loadPreferences(user_screen_name);
		twitbin.taskScheduler.setRateTime(reload_rate);
		twitbin.viewController.viewInterface.hidePreferences();
	},

	removeTweetsCookies: function removeTweetsCookies(){
		//si existe la cookie para reply entonces la borro
		if(twitbin.cookie.exist('in_reply_to_status_id')){
			twitbin.cookie.remove('in_reply_to_status_id');
		}
		if(twitbin.cookie.exist('image_attached')){
			twitbin.cookie.remove('image_attached');
		}
	},

	haveUrl: function haveUrl(tweet){
		var j,matching,
		match = tweet.match(/(((https?)|(ftp)):\/\/([\-\w]+\.)+\w{2,3}(\/[%\-\w]+(\.\w{2,})?)*(([\w\-\?\+@&#;`~=%]*)(\.\w{2,})?)*\/?)/gi);

		if(!match){ return false; }//no hay urls en el tweet

		for(j in match){//busco entre todas las urls del tweet una que no este acortada
			matching = match[j];
			if(matching.length > 20){// solo busco las urls que tienen mas de 20 caracteres para acortarlas
				return matching;//si encuentro una url no acortada entonces la retorno
			}
		}
		return false;// no habian urls no acortadas
	},

	openUrl: function openUrl(url) {
		var gBrowser=this.mainWindow.getBrowser();

		gBrowser.selectedTab = gBrowser.addTab(url);
	},

	openAuthorizeUrl: function openUrl(url) {
		var newTabBrowser,html_obtained,matches,PIN_aux,PIN,
		gBrowser=this.mainWindow.getBrowser();

		gBrowser.selectedTab = gBrowser.addTab(url);
		newTabBrowser = gBrowser.getBrowserForTab(gBrowser.selectedTab);  
		newTabBrowser.addEventListener("load", function () {
			if(twitbin.permitedAccessForTwitbin()){
				html_obtained = newTabBrowser.contentDocument.body.innerHTML;
				matches = html_obtained.match(/<code>[0-9a-zA-Z]*<\/code>/g);
				PIN_aux = matches[0].replace("<code>","");
				PIN = PIN_aux.replace("</code>","");

				twitbin.viewController.viewInterface.SetPIN_OnFields(PIN);
			}

		}, true);
	},

	openUrlBAN: function (url) {
		var uri,cookieSvc,cookie,aux,obj,c_value,exdate,i,j,x,y,ARRcookies,
		gBrowser=this.mainWindow.getBrowser(),
		ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);

		uri = ios.newURI("http://d1.openx.org/", null, null);
		cookieSvc = Components.classes["@mozilla.org/cookieService;1"].getService(Components.interfaces.nsICookieService);
		cookie = cookieSvc.getCookieString(uri, null);
		ARRcookies=cookie.split(";");

		for (i=0;i<ARRcookies.length;i++)
		{
			x=ARRcookies[i].substr(0,ARRcookies[i].indexOf("="));
			y=ARRcookies[i].substr(ARRcookies[i].indexOf("=")+1);
			x=x.replace(/^\s+|\s+$/g,"");
			if ( x == 'OAVARS[default]')
			{
					y=decodeURIComponent(y);
					y= y.replace(/a:[0-9]*\:\{/g, '');
					y= y.replace(/s:[0-9]*\:/g, '');
					y= y.replace(/\i\:/g, '');
					y= y.replace(/\"/g, '');
					y= y.replace(/\}/g, '');
					y=y.split(';');
					obj='{';
					for (j=0; j < y.length -1; j++ )
					{
						obj+= '"' +y[j]+ '": "' + y[j+1]+ '"';
						if ((j + 2) !=  (y.length -1) ) { obj+= ','; }
						j++;
					}
					obj += "}";
					aux = $.parseJSON (obj);
					url=url.replace(/TWITBINA/i, aux.bannerid)
						.replace(/TWITBINA/i, aux.bannerid)
						.replace(/TWITBINB/i, aux.OXLCA)
						.replace(/TWITBINC/i, aux.r_id)
						.replace(/TWITBIND/i, aux.r_ts)
						.replace(/TWITBINE/i, aux.oadest);
					break;
			}
		}

		gBrowser=this.mainWindow.getBrowser();
		gBrowser.selectedTab = gBrowser.addTab(url);
	},

	permitedAccessForTwitbin: function () {
		var gBrowser=this.mainWindow.getBrowser();
		if (gBrowser.contentDocument.location == 'https://api.twitter.com/oauth/authorize') {
			return true;
		}
		return false;
	},

	closeTwitterPinPage: function () {
		var gBrowser=this.mainWindow.getBrowser();
		gBrowser.removeCurrentTab();
	},

//--------------------------------------------
//	 TO SORT
//--------------------------------------------

	//llmara directamente a view interface
	showErrorMessage: function showErrorMessage(msg){
		if((msg == null) || (msg == 'null')){return true;}
		twitbin.viewController.viewInterface.notificationArea("show","info",msg);
	},

}//of prototype twitbin
