	function TwitbinOverlay () {
		this.twitbinHtmlUrl = "chrome://twitbin/content/index.html";
	}

	TwitbinOverlay.prototype={

		/**
		* Loading the Jquery from the mozilla subscript method
		 *
		 * @return void
		 * @access public
		*/
		loadJQuery:  function(context) {
			if(!twitbinOver.jQuery) {
				var loader = Components.classes["@mozilla.org/moz/jssubscript-loader;1"].getService(Components.interfaces.mozIJSSubScriptLoader);
				loader.loadSubScript("chrome://twitbin/content/js/libs/jquery-1.6.1.min.js",context);
				var jQuery = window.jQuery.noConflict(true);
				if( typeof(jQuery.fn._init) == 'undefined') { jQuery.fn._init = jQuery.fn.init; }
				twitbinOver.jQuery = jQuery;
			}
		},

		/**
		* Thins to do when this begin
		 *
		 * @return void
		 * @access public
		*/
		init: function () {
			var icon = false,
			twitbin= false;

			twitbinOver.setWidth();
			twitbinOver.loadHtml();
			twitbinOver.loadJQuery(twitbinOver);


			if(typeof(top.document.getElementById("twitbin-button")) != "undefined"){
				icon = true;
			}

			if (icon && twitbinOver.sidebarStatus() == 'vissible') {
				twitbinOver.jQuery("#twitbin-button",top.document).attr('active', 'yes');
			}

			//add handler to show/hide twit this picture context menu
			var menu = document.getElementById("contentAreaContextMenu");
			menu.addEventListener("popupshowing", twitbinOver.showHideContextMenuItem, false);
		},

		/**
		* Thins to do when this finish
		 *
		 * @return void
		 * @access public
		*/
		end: function (){

		},

		/**
		* This function adds Twitbin icon to the navbar if it is not present there.
		 *
		 * @return void
		 * @access public
		*/
		addIconToNavBar: function () {

			var toolbox = document.getElementById("navigator-toolbox");
			var toolboxDocument = toolbox.ownerDocument;
			var hasTwitbinButton = false;

			// serach for button
			for (var i = 0; i < toolbox.childNodes.length; ++i) {
				var toolbar = toolbox.childNodes[i];
				if (toolbar.localName == "toolbar" && toolbar.getAttribute("customizable") == "true" ) {
					if (toolbar.currentSet.indexOf("twitbin-button") > -1) {
						hasTwitbinButton = true;
					}
				}
			}

			//add it if not pressent
			if (hasTwitbinButton) { return true; }

			for (var i = 0; i < toolbox.childNodes.length; ++i) {
				toolbar = toolbox.childNodes[i];
				if (toolbar.localName == "toolbar" &&  toolbar.getAttribute("customizable") == "true" && toolbar.id == "nav-bar") {

					var newSet = "";
					var child = toolbar.firstChild;
					while (child) {
						if (!hasTwitbinButton && (child.id=="twitbin-button" || child.id=="urlbar-container")) {
							newSet += "twitbin-button,";
							hasTwitbinButton = true;
						}
						newSet += child.id + ",";
						child = child.nextSibling;
					}
					newSet = newSet.substring(0, newSet.length-1);

					toolbar.currentSet = newSet;
					toolbar.setAttribute("currentset", newSet);
					toolboxDocument.persist(toolbar.id, "currentset");
					BrowserToolboxCustomizeDone(true);
					break;
				}
			}
		},

		/**
		* This function is called when Twitbin sidebar is toggled and loads url in the sidebar if it is open.
		 *
		 * @return void
		 * @access public
		*/
		loadHtml: function ()  {
			var sidebar = top.document.getElementById("sidebar");
			var broadcaster = top.document.getElementById('TwitbinSideBar');

			if (broadcaster.hasAttribute('checked')) {
				sidebar.loadURI(twitbinOver.twitbinHtmlUrl);
			}
		},

		/**
		* Set width style for side bar
		 *
		 * @return void
		 * @access public
		*/
		setWidth: function () {
			twitbinOver.loadJQuery(twitbinOver);
			twitbinOver.jQuery("#sidebar-box",window.top.document).css({"min-width":"320px", "max-width":"370px", 'width': '320px'});
		},

		/**
		* Handle the action over the bird botton icon.
		 * Check if the side bar not exist or it is hidden, and does
		 * the correct action depending on it's status
		 *
		 * @param EventObject event: teel us what button has been pressed
		 * @return void
		 * @access public
		*/
		handleSideBar: function(event) {
			//event.button 0: (left click); 1: (middle click); 2: (right click)
			if (event.button == 2) { return true; }

			twitbinOver.loadJQuery(twitbinOver);

			var sidebarStatus, sidebarHtmlUrl, twitbin, current_tab;

			//get sidebar status
			sidebarStatus = twitbinOver.sidebarStatus();
			sidebarHtmlUrl = top.document.getElementById("sidebar").contentWindow.location.href;

			//get twitbin object if exist and the last viewed twitbin tab 
			if(typeof(top.document.getElementById("sidebar").contentWindow.twitbin) != "undefined"){
				twitbin = top.document.getElementById("sidebar").contentWindow.twitbin;
				current_tab = twitbin.viewController.viewCurrent;
			}

			//Open sidebar, this load index.html on sidebar and create twitbin object, etc
			if(sidebarStatus == 'noExists') {
				toggleSidebar('TwitbinSideBar');
				twitbinOver.jQuery("#TwitbinSideBar",top.document).attr('checked', true);
				twitbinOver.jQuery("#twitbin-button",top.document).attr('active', 'yes');
				return true;
			}

			//hide sidebar but keep it running
			if(sidebarStatus == 'vissible') {
				//lo comentado es porque seguramente la url siempre cambia agregandole un # al final o algo
				//if(sidebarHtmlUrl != twitbinOver.twitbinHtmlUrl ) { 
					//twitbinOver.init();
				//}else{
					twitbinOver.jQuery("#sidebar",top.document).hide();
					twitbinOver.jQuery("#sidebar-box",top.document).hide();
					twitbinOver.jQuery("#TwitbinSideBar",top.document).attr('checked', false);
				//}
				return true;
			}

			// show sidebar with the last tab opened
			if(sidebarStatus == 'hidden') {
				//user may oppened other sidebar, so we need to load twitbin again
				//if(sidebarHtmlUrl != twitbinOver.twitbinHtmlUrl ) { 
					//twitbinOver.init();
				//}

				twitbinOver.jQuery("#sidebar",top.document).css('display', '');
				twitbinOver.jQuery("#sidebar-box",top.document).css('display', '');
				twitbinOver.jQuery("#TwitbinSideBar",top.document).attr('checked', true);

				switch(current_tab){
					case "TimeLine":
						twitbin.viewController.showTimeLineTweets();
					break;

					case "Mention":
						twitbin.viewController.showMentionsTweets();
					break;

					case "direct_messages":
						twitbin.viewController.showDirectMessages();
					break;

					case "Favorite":
						twitbin.viewController.showFavoriteTweets();
					break;

					case "List":
						twitbin.viewController.showAllList();
					break;

					case "searches":
						twitbin.viewController.showSearches();
					break;
				}

				return true;
			}

		},

		/**
		* Return the current status of the sidebar
		 *
		 * @return string: sidebar status
		 * @access public
		*/
		sidebarStatus: function () {
			var sidebar_box = top.document.getElementById("sidebar-box"),
			sidebar = top.document.getElementById("sidebar");

			if(sidebar_box.getAttribute("hidden")){
				//si esta escondido quiere decir que la pagina no esta cargada
				//ergo el objeto twitbin no existe
				return 'noExists';
			}

			if (sidebar.style.display == "none" ){
				return 'hidden';
			}

			return 'vissible';
		},

		/**
		* Handler to display Twit this image only when context menu open over a image
		 *
		 * @return string: sidebar status
		 * @access public
		*/
		showHideContextMenuItem: function () {
			gContextMenu.showItem("twitbin-twitThisImage-menuitem", gContextMenu.onImage );
		},

		/**
		* Handle the action over "Twit this page" on FF context menu.
		 *
		 * @param string URL: url to be sortened or null to use browser current tab url
		 * @return void
		 * @access public
		*/
		shareURL: function (url) {
			var image = false;
			twitbinOver.loadJQuery(twitbinOver);

			if (twitbinOver.jQuery.inArray( twitbinOver.sidebarStatus(), ["noExists", "hidden"]) != -1) {
				twitbinOver.handleSideBar({"button": 1});
			}

			if (url) {
				longUrl = url; //encodeURIComponent(url);
				image = true;
			} else {
				longUrl = content.wrappedJSObject.location; //encodeURIComponent(content.wrappedJSObject.location);
			}
			//top.document.getElementById("sidebar").contentWindow.twitbin.ShortenURL(tweet,url,'change');

			var cox = new TwitbinHttpRequest ();
			var url = "http://api.bit.ly/v3/shorten?login=twitbin&apiKey=R_6832fe42e74ac086234b761422395d36&longUrl="+longUrl+"&format=json"

			cox.setURI(url);
			cox.setOnLoadFunction (function(datos){
				// datos = { "status_code": 200, "status_txt": "OK", "data": { "long_url": "http:\/\/www.google.com.ar\/", "url": "http:\/\/bit.ly\/chUkKE", "hash": "chUkKE", "global_hash": "funN", "new_hash": 0 } }
				var res = twitbinOver.jQuery.parseJSON(datos);
				if (res.status_txt == 'OK')
				{
					var surl = res.data.url;
					var context = top.document.getElementById("sidebar").contentDocument;
					twitbinOver.jQuery("#searchbox textarea",context).focus();

					if(!top.document.getElementById("sidebar").contentWindow.twitbin.userLogged()) {
						twitbinOver.jQuery("#searchbox textarea",context).val(surl);
					}else{
						var open = top.document.getElementById("sidebar").contentWindow.twitbin.viewController.viewInterface.tweetAreaItsOpen();
						if(open && (top.document.getElementById("sidebar").contentWindow.twitbin.viewController.viewInterface.getTweetTextarea() != "")){
							twitbinOver.jQuery("#searchbox textarea",context).val(twitbinOver.jQuery("#searchbox textarea",context).val()+" "+surl);
						}else{
							twitbinOver.jQuery("#searchbox textarea",context).val(surl);
						}
					}

					top.document.getElementById("sidebar").contentWindow.twitbin.cookie.create('Setedurl', 'true');

					//Reports
					if(top.document.getElementById("sidebar").contentWindow.twitbin.userLogged()){
						if(image){
							top.document.getElementById("sidebar").contentWindow.twitbin.reports.add('Session.links');
						}else{
							top.document.getElementById("sidebar").contentWindow.twitbin.reports.add('Session.tweet_this_page');
						}
					}
				}
			});
			cox.asyncOpen(true);
		},

		/**
		* Handle the action over "Twit this Picture" on FF context menu.
		 * take the url of an image and pass it to shortURL function.
		 *
		 * @return void
		 * @access public
		*/
		shareIMG: function () {
			if (gContextMenu.onImage) {
				var url = gContextMenu.imageURL;
				twitbinOver.shareURL(url);//true indica que es una imagen
			}
		},

		/**
		* Handle the action over "Twits about this age" on FF context menu.
		 *
		 * @return void
		 * @access public
		*/
		searchURL: function ()  {
			var status = twitbinOver.sidebarStatus();
			if (twitbinOver.jQuery.inArray( status, ["noExists", "hidden"]) != -1) {
				twitbinOver.handleSideBar({"button": 1});
			}
			if((status == "noExists")||(!top.document.getElementById("sidebar").contentWindow.twitbin.userLogged())){
					setTimeout(function(){twitbinOver.sendTaskToTwitbin(content.wrappedJSObject.location.hostname,content.wrappedJSObject.location)}, 1000);
			}else{
				top.document.getElementById("sidebar").contentWindow.twitbin.cookie.create('search_url', content.wrappedJSObject.location.hostname);
				top.document.getElementById("sidebar").contentWindow.twitbin.cookie.create('search_query', content.wrappedJSObject.location);
				top.document.getElementById("sidebar").contentWindow.twitbin.startTempSearch(content.wrappedJSObject.location);

				//Reports
				if(top.document.getElementById("sidebar").contentWindow.twitbin.userLogged()){
					top.document.getElementById("sidebar").contentWindow.twitbin.reports.add('Session.tweets_about_this_page');
				}
			}
		},

		sendTaskToTwitbin: function(name, query){
			top.document.getElementById("sidebar").contentWindow.twitbin.cookie.create('search_url', name);
			top.document.getElementById("sidebar").contentWindow.twitbin.cookie.create('search_query', query);
			top.document.getElementById("sidebar").contentWindow.twitbin.setFunctionToExecuteOnInit("twitbin.startTempSearch",[query]);
		}

	};

	twitbinOver = null;
	twitbinOver=new TwitbinOverlay();
	window.addEventListener("load", function(){ twitbinOver.init(); }, true);
